LM_regression <-  function(u_stand, K, Samp,spec, H, h){
  # loop through all residuals 
  u_stand  <-  as.matrix(u_stand)
  p_LM <-  vector(mode="numeric", length=H)
  LM_stat <-  vector(mode="numeric", length=H)
  
  for (j in 1:H){
    eta <- matrix(NA, 0.5*(K*(K+1)), (Samp-spec$lag))
    nu <- matrix(NA, 0.5*(K*(K+1)), (Samp-spec$lag))
    
    for (i in 1:(Samp-spec$lag)){
      eta[,i] <- vech(u_stand[i,]%*%t(u_stand[i,]))
    }
    eta <- as.matrix(t(eta))
    
    # regression on the different lags of eta     
    eta_lag<- y_lag_cr(eta, j)$lags
    eta <- as.matrix(eta[-(1:j),])
    # auxilliary regression to obtain Sigma0 (Luetkepohl page 576)
    con <- matrix(1,(Samp-spec$lag-j),1)
    Z0 <-   con 
    # regression on just a constant to get Sigma0 
    Theta0 <- t(eta)%*%Z0%*%solve(t(Z0)%*%Z0)
    omega0 <- residuals3(eta,Theta0,Z0)  
    Sigma0 <- (Samp-spec$lag-j)^-1*t(omega0)%*%omega0
    # alternatively: Gamma0
    for (i in 1:(Samp-spec$lag)){
      nu[,i] <- vech(u_stand[i,]%*%t(u_stand[i,])) - (Samp-spec$lag)^-1*vech(t(u_stand)%*%u_stand)
    }
    Gamma0 <- (Samp-spec$lag)^-1*nu%*%t(nu) 
    #generate Z matrix
    con <- matrix(1,(Samp-spec$lag)-j,1)
    Z <- cbind(con,eta_lag)
    
    # regression 
    Theta <- t(eta)%*%Z%*%solve(t(Z)%*%Z)
    # get residuals to calculate initial B
    omega_est <- residuals3(eta,Theta,Z)  
    Sigma_om <- (Samp-spec$lag-j)^-1*t(omega_est)%*%omega_est
    # generate the (sum of) the auto_covariance matrices
    #variance, i.e. Gamma(0)
    LM_stat[j] <-  0.5 * (Samp-spec$lag-j)*(K-h)*(K-h+1) - (Samp-spec$lag-j)*matTrace(Sigma_om%*%solve(Sigma0))
    p_LM[j] <- 1- pchisq(LM_stat[j], df=(0.25*j*(K-h)^2*(K-h+1)^2))
  }
  
  out <-  list(test_LM = LM_stat, p_LM=p_LM)
  return(out)
  
}# end of function