MSE_var <- function(B, Theta, Lambda, horizon, K, spec,lag_length){
  
  int <- Theta[1:K,1]
  col <- 2
  if (dim(Theta)[2]/(K*spec$lag+1)!=1){
    trend <- Theta[1:K,2]
    col <- 3
  }
  
  # Write in VAR(1) representation (Companion form)
  nu <- c(int, vector(mode="numeric", length= K*lag_length-K) )
  if (lag_length == 1){
    A_var <- Theta[,2:dim(Theta)[2]]
  } else if (lag_length > 1){
    diag_help <- cbind(diag(K*lag_length-K), matrix(0,K*lag_length-K,K))
    A_var <- rbind(Theta[,col:dim(Theta)[2]], diag_help)
  } 
  # calculate the characteristical polynomial
  char_poly <-  diag(K*lag_length)-A_var
  # caluclate the mean
  mean <- (solve(char_poly)%*%nu)[1:K]
  # derive the MA-coefficients (phi) by multiplication of J and A^i (Lütkepohl page 18)
  MSE_var <- array(NA, dim=c(K,K,horizon+1, states))
  for (j in 1:spec$states){
    for (i in 0:horizon){
      
      MSE_var_step <- matrix.power(as.matrix(A_var),i)%*%B%*%Lambda[((j-1)*K+1):((j)*K),]%*%t(B)%*%t(matrix.power(as.matrix(A_var),i))
      if (i==0){
        MSE_var[,,(i+1),j] <- MSE_var_step
      } else if (i >0){
        MSE_var[,,(i+1),j] <- MSE_var_step + MSE_var[,,i,j] 
      }
    }
  }
  return(list(MSE_var=MSE_var))
  
}