calc_pval <- function(data_list, f_test_eval,f_test_eval_robust, sims, K=4,Samp, spec, ins_dim){
  lls <- c()
  for (i in 1:sims){
    lls <- rbind(lls, cbind(ifelse(is.null(data_list[[1]][[i]]$ll_ms),-10^10,data_list[[1]][[i]]$ll_ms), ifelse(is.null(data_list[[2]][[i]]$ll_ms),-10^10,data_list[[2]][[i]]$ll_ms), ifelse(is.null(data_list[[3]][[i]]$ll_ms),-10^10,data_list[[3]][[i]]$ll_ms),ifelse(is.null(data_list[[4]][[i]]$ll_ms),-10^10,data_list[[4]][[i]]$ll_ms)))
  }
  colMeans(correlations)
  lls_diff <- t(rbind(lls[,1]-lls[,2],lls[,1]-lls[,3],lls[,1]-lls[,4]) )
  lls_order <- cbind( as.numeric(trunc(lls[,1],2)>=trunc(lls[,2],2)),as.numeric(trunc(lls[,2],2)>=trunc(lls[,3],2)), as.numeric(trunc(lls[,3],2)>=trunc(lls[,4],2)))
  rel_column <-  vector(mode="numeric", 3)
  rel_endo  <-  vector(mode="numeric", 3)
  rel_strength <-  vector(mode="numeric", 3)
  rel_f <-  vector(mode="numeric", 3)
  rel_f_robust <-  vector(mode="numeric", 3)
  
  
  level <- c(0.01,0.05,0.1) 
  for (lvl in 1:3){
    # lvl <- 1
    sig <- level[lvl]
    for (i in 1:sims){
      # i=1
      if (lr_test(lls[i,1], lls[i,2], df=ins_dim*K)$p_LR < sig) {
        rel_column[lvl] <-  rel_column[lvl] +1
      }
      if (lr_test(lls[i,2], lls[i,3], df=ins_dim*(K-1))$p_LR < sig) {
        rel_endo[lvl] <-  rel_endo[lvl] +1
      }  
      if (lr_test(lls[i,3], lls[i,4], df=ins_dim)$p_LR < sig) {
        rel_strength[lvl] <-  rel_strength[lvl] +1
      }
      
      if ((1- pf(f_test_eval[i], df1=ins_dim, df2=Samp-spec$lag )) < sig) {
        rel_f[lvl] <-  rel_f[lvl] +1
      }
      if ( (1-pf(f_test_eval_robust[i], df1=ins_dim, df2=Samp-spec$lag )) < sig) {
        rel_f_robust[lvl] <-  rel_f_robust[lvl] +1
      }
    }
    rel_column[lvl] <- rel_column[lvl]/sims
    rel_endo[lvl] <- rel_endo[lvl]/sims
    rel_strength[lvl] <- rel_strength[lvl]/sims
    rel_f[lvl] <- rel_f[lvl]/sims
    rel_f_robust[lvl] <- rel_f_robust[lvl]/sims
  }
  out <- list(lls=lls,rel_column=rel_column, rel_endo=rel_endo, rel_strength=rel_strength,rel_f_robust=rel_f_robust, rel_f=rel_f)
  return(out)
}