calc_variance_decomp <- function(Phi, struc_error, K,  spec,  horizon){
  var_decomp <- array(NA, dim=c(horizon,K,K, spec$states))
  for (m in 1:spec$states){
    MSE_y <- array(data=NA, dim=c(dim(Phi[,,1,1])[1], dim(Phi[,,1,1])[1], horizon ))
    
    MSE_yjt <- array(data=NA, dim=c(dim(Phi[,,1,1])[1], horizon ))
    
    for (h in 1:horizon){
      MSE_y[,,h] <-  Phi[,,h,m]%*%t(Phi[,,h,m])
      if (h == 1){
        MSE_yjt[,h] <-  diag(MSE_y[,,h])  
      } else if (h != 1){
        MSE_yjt[,h] <- MSE_yjt[,(h-1)] + diag(MSE_y[,,h])    
      }
    }
    
    ident <-  diag(rep(K))
    omega_jk = c()
    
    for (j in 1:K){
      e_j <- ident[,j]
      for (k in 1:K){
        e_k <- ident[,k]
        omega_jk <- c()
        omega_jk_help <- c()
        for (h in 1:horizon){
          if (h == 1){
            omega_jk_help[1] <- (t(e_j)%*%Phi[,,h,m]%*%e_k)^2
          } else if (h != 1) {
            omega_jk_help[h] <-  omega_jk_help[h-1] + (t(e_j)%*%Phi[,,h,m]%*%e_k)^2
          }
          omega_jk[h] <- omega_jk_help[h]/MSE_yjt[j,h]   
        }
        var_decomp[,k,j,m] <- omega_jk
      }
    }
  }
  
  return(var_decomp)  
} # function end
