mse_complete_weighted_plag <-  function(data_list, B_true, Lambda_true, Theta_true, sims, K, aug_var, norm=FALSE, ins_dim){

  horizon_max <- 25
  imp_rep_true <-  calc_imp_response(B_true, Theta_true, Lambda_true, horizon_max, K, spec,lag_length)
  # use the MSE FC-error variance as weight
  weight <- MSE_var(B_true, Theta_true, Lambda_true, horizon_max, K, spec,lag_length)
  
  #####################################
  #                                   #
  # Setting up variables and arrays   #
  #                                   #
  #####################################
  
  var_names <- c("mse_invarB","mse_invarB_res","mse_phvar","mse_hvar", "mse_proxy", "mse_plag")    
  mse_step_FC <- array(NA, dim= c( K^2, sims,horizon_max, 6))
  mse_step_sum_FC <- array(NA, dim= c( K^2, sims, 6))
  mse_step_sum_5_FC <- array(NA, dim= c( K^2, sims, 6))
  mse_step_sum_10_FC <- array(NA, dim= c( K^2, sims, 6))
  mse_step_sum_25_FC <- array(NA, dim= c( K^2, sims, 6))
  mse_step_sum_impact_FC <- array(NA, dim= c( K^2, sims, 6))
  mse_step <- array(NA, dim= c( K^2, sims,horizon_max, 6))
  mse_step_sum <- array(NA, dim= c( K^2, sims, 6))
  mse_step_sum_5 <- array(NA, dim= c( K^2, sims, 6))
  mse_step_sum_10 <- array(NA, dim= c( K^2, sims, 6))
  mse_step_sum_25 <- array(NA, dim= c( K^2, sims, 6))
  mse_step_sum_impact <- array(NA, dim= c( K^2, sims, 6))
  
  # the number of models with the largest MSEs that are cutted 
  cut_top <- ifelse(sims<15, 2, 10)
  max_index <- matrix(NA, 6, cut_top)
  rownames(max_index) <- c("invarB","invarB_res","ph_var","h_var", "pr_var", "plag_var")
  max_index_5 <- matrix(NA, 6, cut_top)
  max_index_10 <- matrix(NA, 6, cut_top)
  max_index_25 <- matrix(NA, 6, cut_top)
  max_index_impact <- matrix(NA, 6, cut_top)
  max_index_FC <- matrix(NA, 6, cut_top)
  rownames(max_index) <- c("invarB","invarB_res","ph_var","h_var", "pr_var", "plag_var")
  max_index_5_FC <- matrix(NA, 6, cut_top)
  max_index_10_FC <- matrix(NA, 6, cut_top)
  max_index_25_FC <- matrix(NA, 6, cut_top)
  max_index_impact_FC <- matrix(NA, 6, cut_top)
  
  for (i in 1:4){
    for (j in 1:sims){
      data_list[[i]][[j]]$Phi_coef_cut <- data_list[[i]][[j]]$Phi_coef[-c((K+1):(K+ins_dim)),-c((K+1):(K+ins_dim)),,]
    }
  }  
  for (j in 1:sims){
    data_list[[5]][[j]]$Phi_coef_cut <- array(data=NA, dim = c(dim(data_list[[5]][[j]]$Phi),2))
    data_list[[5]][[j]]$Phi_coef_cut[,1,,1] <- data_list[[5]][[j]]$Phi[,1,]
    data_list[[6]][[j]]$Phi_coef_cut <- array(data=NA, dim = c(dim(data_list[[6]][[j]]$Phi),2))
    data_list[[6]][[j]]$Phi_coef_cut[,1,,1] <- data_list[[6]][[j]]$Phi[,1,]
  }
  # TRue IRF
  Phi_coef_true <- imp_rep_true$Phi[,,,1]
  # Extract PH-VAR MSE for normalization of with stepwise Relative MSE
  PH_Phi_coef_array <-  array(data=NA, dim= c(dim(data_list[[3]][[1]]$Phi_coef_cut)[1],dim(data_list[[3]][[1]]$Phi_coef_cut)[2], dim(data_list[[3]][[1]]$Phi_coef_cut)[3], sims ) )
  PH_mse_step <-  array(NA, dim= c( K^2, sims,horizon_max))
  for (j in 1:sims){
    if (is.null(data_list[[3]][[j]]$Phi_coef_cut[,,,1])){
      PH_Phi_coef_array[,,,j] <- array(10^5, dim= c(dim(data_list[[3]][[1]]$Phi_coef_cut)[1],dim(data_list[[3]][[1]]$Phi_coef_cut)[2], dim(data_list[[3]][[1]]$Phi_coef_cut)[3]))
    } else {
      PH_Phi_coef_array[,,,j] <- data_list[[3]][[j]]$Phi_coef_cut[,,,1]
    }
    for (i in 1:horizon_max){
      PH_mse_step[,j,i] <- c(Phi_coef_true[,,i] - PH_Phi_coef_array[1:K,1:K,i,j])^2 
    }
  }
  PH_mse_horizon <- apply(PH_mse_step[,,] ,1, function(x) apply(x, 2, function(y) sum(y, na.rm=TRUE)))
  # ----------------------------------------------------------------------------- #
  #                                                                               #
  # This part calculates the MSE of all models for each simulation                #
  #                                                                               #
  # ----------------------------------------------------------------------------- #
  # n is looping through models
  for (n in 1:6){
    # n=3
    # select the respective Impulse response functions, depending on whether the normalized B or not is required
    if (norm ==  FALSE){
      Phi_coef_array <-  array(data=NA, dim= c(dim(data_list[[n]][[1]]$Phi_coef_cut)[1],dim(data_list[[n]][[1]]$Phi_coef_cut)[2], dim(data_list[[n]][[1]]$Phi_coef_cut)[3], sims ) )
      for (i in 1:sims){
        if (is.null(data_list[[n]][[i]]$Phi_coef_cut[,,,1])){
          Phi_coef_array[,,,i] <- array(10^5, dim= c(dim(data_list[[n]][[1]]$Phi_coef_cut)[1],dim(data_list[[n]][[1]]$Phi_coef_cut)[2], dim(data_list[[n]][[1]]$Phi_coef_cut)[3]))
        } else {
          Phi_coef_array[,,,i] <- data_list[[n]][[i]]$Phi_coef_cut[,,,1]
        }
      }
      # Select the impulse response function for the true model (does not vary over the simulations, since it is always true)
      
    } else if (norm == TRUE){
      Phi_coef_array <-  array(data=NA, dim= c(dim(data_list[[n]][[1]]$Phi_coef_cut)[1],dim(data_list[[n]][[1]]$Phi_coef_cut)[2], dim(data_list[[n]][[1]]$Phi_coef_cut)[3], sims ) )
      for (i in 1:sims){
        if (is.null(data_list[[n]][[i]]$Phi_coef_cut[,,,2])){
          Phi_coef_array[,,,i] <- array(10^5, dim= c(dim(data_list[[n]][[1]]$Phi_coef_cut)[1],dim(data_list[[n]][[1]]$Phi_coef_cut)[2], dim(data_list[[n]][[1]]$Phi_coef_cut)[3]))
        } else {
          Phi_coef_array[,,,i] <- data_list[[n]][[i]]$Phi_coef_cut[,,,2]
        }
      }  
      # Select the impulse response function for the true model (does not vary over the simulations, since it is always true)
      Phi_coef_true <- imp_rep_true$Phi[,,,2]
    }
    
    # i is the horizon
    # j is the number of simulation
    for (i in 1:horizon_max){
      for (j in 1:sims){
        # Stepwise MSEs
        # weighted by FC-Error Variance Matrix
        mse_step_FC[,j,i,n] <- c(Phi_coef_true[,,i] - Phi_coef_array[1:K,1:K,i,j])^2*diag(weight$MSE_var[,,i,1]) 
        # normalized with PH-VAR 
        mse_step[,j,i,n] <- c(Phi_coef_true[,,i] - Phi_coef_array[1:K,1:K,i,j])^2
      }
    }
    
    # Calculate the MSEs for different hozions by summing up over the different array dimensions
    mse_FC <- apply(apply(mse_step_FC[,,,n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE))), 1, sum)/sims
    mse_5_FC <- apply(apply(mse_step_FC[,,(1:5),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE))), 1, sum)/sims
    mse_10_FC <- apply(apply(mse_step_FC[,,(1:10),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE))), 1, sum)/sims
    mse_25_FC <- apply(apply(mse_step_FC[,,(1:25),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE))), 1, sum)/sims
    mse_impact_FC <- apply(as.matrix(apply(as.matrix(mse_step_FC[,,(1:1),n]) ,2, function(x) apply(as.matrix(x), 1, function(y) sum(as.matrix(y), na.rm=TRUE)))), 1, sum)/sims
    
    # name the mse
    assign(paste(var_names[n], "_FC", sep=""), mse_FC )
    assign(paste(var_names[n], "_5_FC", sep=""), mse_5_FC )
    assign(paste(var_names[n], "_10_FC", sep=""), mse_10_FC )
    assign(paste(var_names[n], "_25_FC", sep=""), mse_25_FC )
    assign(paste(var_names[n], "_impact_FC", sep=""), mse_impact_FC )

    # Calculate the MSEs for different hozions by summing up over the different array dimensions
    mse <- apply(apply(mse_step[,,,n] ,1, function(x) apply(x, 2, function(y) sum(y, na.rm=TRUE)))/PH_mse_horizon, 2, sum)/horizon_max
    mse_5 <- apply(apply(mse_step[,,(1:5),n] ,1, function(x) apply(x, 2, function(y) sum(y, na.rm=TRUE)))/PH_mse_horizon[1:5,], 2, sum)/5
    mse_10 <- apply(apply(mse_step[,,(1:10),n] ,1, function(x) apply(x, 2, function(y) sum(y, na.rm=TRUE)))/PH_mse_horizon[1:10,], 2, sum)/10
    mse_25 <- apply(apply(mse_step[,,(1:25),n] ,1, function(x) apply(x, 2, function(y) sum(y, na.rm=TRUE)))/PH_mse_horizon[1:25,], 2, sum)/25
    mse_impact <- apply(matrix(apply(as.matrix(mse_step[,,(1:1),n]) ,1, function(x) apply(as.matrix(x), 2, function(y) sum(as.matrix(y), na.rm=TRUE))), nrow=1)/PH_mse_horizon[1,], 2, sum)
    
    # name the mse
    assign(paste(var_names[n]), mse )
    assign(paste(var_names[n], "_5", sep=""), mse_5 )
    assign(paste(var_names[n], "_10", sep=""), mse_10 )
    assign(paste(var_names[n], "_25", sep=""), mse_25 )
    assign(paste(var_names[n], "_impact", sep=""), mse_impact )
    
    # save MSE of true model
    if (var_names[n] == "mse_phvar"){
      mse_true_FC <- mse_FC
      mse_true_5_FC <- mse_5_FC
      mse_true_10_FC <- mse_10_FC
      mse_true_25_FC <- mse_25_FC
      mse_true_impact_FC <- mse_impact_FC
      mse_true <- mse
      mse_true_5 <- mse_5
      mse_true_10 <- mse_10
      mse_true_25 <- mse_25
      mse_true_impact <- mse_impact
      
    }
  } #end of loop through models
  ### FIND THE LARGEST ELEMENTS THAT MIGHT DRIVE THE MSEs ####
  for (n in 1:6){
  # n=1  
    # this is the sum over the first 5 horizons of the MSE for each element of the impulse response function (i.e., dimension is K^2 for each element with 500 repetions)
    mse_step_sum_FC[,,n] <- apply(mse_step_FC[,,,n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE)))
    mse_step_sum_5_FC[,,n] <- apply(mse_step_FC[,,(1:5),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE)))
    mse_step_sum_10_FC[,,n] <- apply(mse_step_FC[,,(1:10),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE)))
    mse_step_sum_25_FC[,,n] <- apply(mse_step_FC[,,(1:25),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE)))
    mse_step_sum_impact_FC[,,n] <- apply(as.matrix(mse_step_FC[,,(1:1),n]) ,2, function(x) apply(as.matrix(x), 1, function(y) sum(as.matrix(y), na.rm=TRUE)))
    
    mse_step_sum[,,n] <- apply(mse_step[,,,n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE)))
    mse_step_sum_5[,,n] <- apply(mse_step[,,(1:5),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE)))
    mse_step_sum_10[,,n] <- apply(mse_step[,,(1:10),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE)))
    mse_step_sum_25[,,n] <- apply(mse_step[,,(1:25),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE)))
    mse_step_sum_impact[,,n] <- apply(as.matrix(mse_step[,,(1:1),n]) ,2, function(x) apply(as.matrix(x), 1, function(y) sum(as.matrix(y), na.rm=TRUE)))
    
  }
  # divide the stepwise MSEs of each model by the TOTAL MSE of the true model. Thus, all MSE are relative and can then be added up over the columns to be comparable to have 
  # a vector in the end that can be evaluated.
  for (n in 1:6){
    # row index of the models with the largest MSEs
    max_index[n,] <- order( colSums(  apply(mse_step_sum[,,n],2, "/",mse_true) ), decreasing=TRUE)[1:cut_top]
    max_index_5[n,] <- order( colSums(  apply(mse_step_sum_5[,,n],2, "/",mse_true_5) ), decreasing=TRUE)[1:cut_top]
    max_index_10[n,] <- order( colSums(  apply(mse_step_sum_10[,,n],2, "/",mse_true_10) ), decreasing=TRUE)[1:cut_top]
    max_index_25[n,] <- order( colSums(  apply(mse_step_sum_25[,,n],2, "/",mse_true_25) ), decreasing=TRUE)[1:cut_top]
    max_index_impact[n,] <- order( colSums(  apply(as.matrix(mse_step_sum_impact[,,n]),2, "/",mse_true_impact) ), decreasing=TRUE)[1:cut_top]
    max_index_FC[n,] <- order( colSums(  apply(mse_step_sum[,,n],2, "/",mse_true_FC) ), decreasing=TRUE)[1:cut_top]
    max_index_5_FC[n,] <- order( colSums(  apply(mse_step_sum_5[,,n],2, "/",mse_true_5_FC) ), decreasing=TRUE)[1:cut_top]
    max_index_10_FC[n,] <- order( colSums(  apply(mse_step_sum_10[,,n],2, "/",mse_true_10_FC) ), decreasing=TRUE)[1:cut_top]
    max_index_25_FC[n,] <- order( colSums(  apply(mse_step_sum_25[,,n],2, "/",mse_true_25_FC) ), decreasing=TRUE)[1:cut_top]
    max_index_impact_FC[n,] <- order( colSums(  apply(as.matrix(mse_step_sum_impact_FC[,,n]),2, "/",mse_true_impact_FC) ), decreasing=TRUE)[1:cut_top]
    
    # this is the sum over the first 5 horizons of the MSE for each element of the impulse response function (i.e., dimension is K^2 for each element with 500 repetions)
    # models with largest MSE are now excluded from calculations
    mse_cut_FC <- apply(apply(mse_step_FC[,-(max_index[n,]),,n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE))), 1, sum)/(sims-cut_top)
    mse_5_cut_FC <- apply(apply(mse_step_FC[,-(max_index[n,]),(1:5),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE))), 1, sum)/(sims-cut_top)
    mse_10_cut_FC <- apply(apply(mse_step_FC[,-(max_index[n,]),(1:10),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE))), 1, sum)/(sims-cut_top)
    mse_25_cut_FC <- apply(apply(mse_step_FC[,-(max_index[n,]),(1:25),n] ,2, function(x) apply(x, 1, function(y) sum(y, na.rm=TRUE))), 1, sum)/(sims-cut_top)
    mse_impact_cut_FC <- apply(apply(as.matrix(mse_step_FC[,-(max_index[n,]),(1:1),n]) ,2, function(x) apply(as.matrix(x), 1, function(y) sum(as.matrix(y), na.rm=TRUE))), 1, sum)/(sims-cut_top)
    
    mse_cut <- apply(apply(mse_step[,-(max_index[n,]),,n] ,1, function(x) apply(x, 2, function(y) sum(y, na.rm=TRUE)))/PH_mse_horizon, 2, sum)/horizon_max
    mse_5_cut <- apply(apply(mse_step[,-(max_index[n,]),(1:5),n] ,1, function(x) apply(x, 2, function(y) sum(y, na.rm=TRUE)))/PH_mse_horizon[1:5,], 2, sum)/5
    mse_10_cut <- apply(apply(mse_step[,-(max_index[n,]),(1:10),n] ,1, function(x) apply(x, 2, function(y) sum(y, na.rm=TRUE)))/PH_mse_horizon[1:10,], 2, sum)/10
    mse_25_cut <- apply(apply(mse_step[,-(max_index[n,]),(1:25),n] ,1, function(x) apply(x, 2, function(y) sum(y, na.rm=TRUE)))/PH_mse_horizon[1:25,], 2, sum)/25
    mse_impact_cut <- apply(matrix(apply(as.matrix(mse_step[,-(max_index[n,]),(1:1),n]) ,1, function(x) apply(as.matrix(x), 2, function(y) sum(as.matrix(y), na.rm=TRUE)))/PH_mse_horizon[1,], nrow=1), 2, sum)
    
    assign(paste(var_names[n], "_cut", sep=""), mse_cut )
    assign(paste(var_names[n], "_5_cut", sep=""), mse_5_cut )
    assign(paste(var_names[n], "_10_cut", sep=""), mse_10_cut )
    assign(paste(var_names[n], "_25_cut", sep=""), mse_10_cut )
    assign(paste(var_names[n], "_impact_cut", sep=""), mse_10_cut )
    assign(paste(var_names[n], "_cut_FC", sep=""), mse_cut_FC )
    assign(paste(var_names[n], "_5_cut_FC", sep=""), mse_5_cut_FC )
    assign(paste(var_names[n], "_10_cut_FC", sep=""), mse_10_cut_FC )
    assign(paste(var_names[n], "_25_cut_FC", sep=""), mse_10_cut_FC )
    assign(paste(var_names[n], "_impact_cut_FC", sep=""), mse_10_cut_FC )
  }
  
  mse_hor <- rbind(mse_invarB, mse_invarB_res,mse_phvar,mse_hvar, mse_proxy, mse_plag)
  mse_hor_cut <- rbind(mse_invarB_cut, mse_invarB_res_cut,mse_phvar_cut,mse_hvar_cut, mse_proxy_cut, mse_plag_cut)
  colnames(mse_hor) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  colnames(mse_hor_cut) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  mse_5 <- rbind(mse_invarB_5, mse_invarB_res_5,mse_phvar_5,mse_hvar_5, mse_proxy_5, mse_plag_5)
  mse_5_cut <- rbind(mse_invarB_5_cut, mse_invarB_res_5_cut,mse_phvar_5_cut,mse_hvar_5_cut, mse_proxy_5_cut, mse_plag_5_cut)
  colnames(mse_5) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  colnames(mse_5_cut) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  mse_10 <- rbind(mse_invarB_10, mse_invarB_res_10,mse_phvar_10,mse_hvar_10, mse_proxy_10 , mse_plag_10)
  mse_10_cut <-  rbind(mse_invarB_10_cut, mse_invarB_res_10_cut,mse_phvar_10_cut,mse_hvar_10_cut, mse_proxy_10_cut, mse_plag_10_cut)
  colnames(mse_10) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  colnames(mse_10_cut) <-c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  mse_25 <- rbind(mse_invarB_25, mse_invarB_res_25,mse_phvar_25,mse_hvar_25, mse_proxy_25, mse_plag_25)
  mse_25_cut <- rbind(mse_invarB_25_cut, mse_invarB_res_25_cut,mse_phvar_25_cut,mse_hvar_25_cut, mse_proxy_25_cut, mse_plag_25_cut)
  colnames(mse_25) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  colnames(mse_25_cut) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  mse_impact <- rbind(mse_invarB_impact, mse_invarB_res_impact,mse_phvar_impact,mse_hvar_impact, mse_proxy_impact, mse_plag_impact)
  mse_impact_cut <- rbind(mse_invarB_impact_cut, mse_invarB_res_impact_cut,mse_phvar_impact_cut,mse_hvar_impact_cut, mse_proxy_impact_cut, mse_plag_impact_cut)
  colnames(mse_impact) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  colnames(mse_impact_cut) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  ###############################
  mse_hor_FC <- rbind(mse_invarB_FC, mse_invarB_res_FC,mse_phvar_FC,mse_hvar_FC, mse_proxy_FC, mse_plag_FC)
  mse_hor_cut_FC <- rbind(mse_invarB_cut_FC, mse_invarB_res_cut_FC,mse_phvar_cut_FC,mse_hvar_cut_FC, mse_proxy_cut_FC, mse_plag_cut_FC)
  colnames(mse_hor_FC) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  colnames(mse_hor_cut_FC) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  mse_5_FC <- rbind(mse_invarB_5_FC, mse_invarB_res_5_FC,mse_phvar_5_FC,mse_hvar_5_FC, mse_proxy_5_FC, mse_plag_5_FC)
  mse_5_cut_FC <- rbind(mse_invarB_5_cut_FC, mse_invarB_res_5_cut_FC,mse_phvar_5_cut_FC,mse_hvar_5_cut_FC, mse_proxy_5_cut_FC, mse_plag_5_cut_FC)
  colnames(mse_5_FC) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  colnames(mse_5_cut_FC) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  mse_10_FC <- rbind(mse_invarB_10_FC, mse_invarB_res_10_FC,mse_phvar_10_FC,mse_hvar_10_FC, mse_proxy_10_FC, mse_plag_10_FC)
  mse_10_cut_FC <-  rbind(mse_invarB_10_cut_FC, mse_invarB_res_10_cut_FC,mse_phvar_10_cut_FC,mse_hvar_10_cut_FC, mse_proxy_10_cut_FC, mse_plag_10_cut_FC)
  colnames(mse_10_FC) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  colnames(mse_10_cut_FC) <-c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  mse_25_FC <- rbind(mse_invarB_25_FC, mse_invarB_res_25_FC,mse_phvar_25_FC,mse_hvar_25_FC, mse_proxy_25_FC, mse_plag_25_FC)
  mse_25_cut_FC <- rbind(mse_invarB_25_cut_FC, mse_invarB_res_25_cut_FC,mse_phvar_25_cut_FC,mse_hvar_25_cut_FC, mse_proxy_25_cut_FC, mse_plag_25_cut_FC)
  colnames(mse_25_FC) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  colnames(mse_25_cut_FC) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  mse_impact_FC <- rbind(mse_invarB_impact_FC, mse_invarB_res_impact_FC,mse_phvar_impact_FC,mse_hvar_impact_FC, mse_proxy_impact_FC, mse_plag_impact_FC)
  mse_impact_cut_FC <- rbind(mse_invarB_impact_cut_FC, mse_invarB_res_impact_cut_FC,mse_phvar_impact_cut_FC,mse_hvar_impact_cut_FC, mse_proxy_impact_cut_FC, mse_plag_impact_cut_FC)
  colnames(mse_impact_FC) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  colnames(mse_impact_cut_FC) <- c("Phi_1","Phi_2","Phi_3","Phi_4","Phi_5","Phi_6","Phi_7","Phi_8","Phi_9")
  
  out <- list(mse_impact_FC = mse_impact_FC, mse_hor_FC = mse_hor_FC, mse_25_FC = mse_25_FC, mse_5_FC = mse_5_FC, mse_10_FC = mse_10_FC,mse_impact_cut_FC=mse_impact_cut_FC, mse_hor_cut_FC=mse_hor_cut_FC, mse_25_cut_FC=mse_25_cut_FC, mse_10_cut_FC=mse_10_cut_FC,mse_5_cut_FC=mse_5_cut_FC,
              mse_impact_rel = mse_impact, mse_hor_rel = mse_hor, mse_25_rel = mse_25, mse_5_rel = mse_5, mse_10_rel = mse_10,mse_impact_cut_rel=mse_impact_cut, mse_hor_cut_rel=mse_hor_cut, mse_25_cut_rel=mse_25_cut, mse_10_cut_rel=mse_10_cut,mse_5_cut_rel=mse_5_cut)
  
  return(out)
} # end of function
