multi_cov <- function(u_stand,K, Samp, spec, H, h ){
  # Portmanteau test -  Lütkepohl page 576.
  # create empty vectors to hold statistics and for calculation
  Q2 <- vector(mode="numeric",length= abs(H))
  p <- vector(mode="numeric",length= abs(H))
  #loop through all residuals 
  
  u_stand  <-   as.matrix(u_stand)
  nu <- matrix(NA, 0.5*(K*(K+1)), (Samp-spec$lag))
  for (i in 1:(Samp-spec$lag)){
    nu[,i] <- t(vech(u_stand[i,]%*%t(u_stand[i,])) - (Samp-spec$lag)^-1*vech(t(u_stand)%*%u_stand))
  } 
  
  #generate the (sum of) the auto_covariance matrices
  
  #variance, i.e. Gamma(0)
  Gamma0 <- (Samp-spec$lag)^-1*nu%*%t(nu) 
  Gamma_j <- matrix(NA, 0.5*(K*(K+1)),0.5*(K*(K+1)))
  
  sum_calcu <- 0
  for (i in 1:abs(H)){
    
    empty <- matrix(0, i, Samp-spec$lag-i )
    t_empty <- matrix(0, Samp-spec$lag, i)
    idn <- diag(1, (Samp-spec$lag-i), (Samp-spec$lag-i))
    F_mat <- rbind(empty, idn)
    F_mat <- cbind(F_mat,t_empty)
    Gamma_j <- (Samp-spec$lag)^-1*nu%*%F_mat%*%t(nu)
    if (H<0) {
      Gamma_j <- t(Gamma_j)
    }
    calcu <- matTrace(t(Gamma_j)%*%solve(Gamma0)%*%Gamma_j%*%solve(Gamma0))
    sum_calcu <- sum_calcu +  calcu 
    Q2[i]  <- (Samp-spec$lag)* sum_calcu
    p[i] <- 1-pchisq(Q2[i], df=(i*(K)^2*(K+1)^2 /4) )
    
  } # end of loop through i
  
  out <- list(test_Q2 =Q2, p_Q2 = p)
  return(out)
} # end of function