####################### Figure 3: ALL MONETARY POLICY IN ONE PLOT ###################################################

proxy_monpol <- pr_var$imp_rep[-5,] 
proxy_mon_upper_int5 <- pr_var$upper_int5[-5,]
proxy_mon_lower_int5 <- pr_var$lower_int5[-5,]

mon_pol_index_ph <- c(1:4)
ph_monpol <- ph_var$imp_rep[mon_pol_index_ph,,]
ph_monpol_upper_int5 <- ph_var$upper_int5[mon_pol_index_ph,,]
ph_monpol_lower_int5 <- ph_var$lower_int5[mon_pol_index_ph,,]

new_order = c(1,2,3,4,5)
mon_pol_index_h <- c(16:19)
h_monpol <- h_var$imp_rep[mon_pol_index_h,,]  
h_monpol_upper_int5 <- h_var$upper_int5[mon_pol_index_h,,]
h_monpol_lower_int5 <- h_var$lower_int5[mon_pol_index_h,,]

joint_results <- list()
joint_results$imp_rep <- array(data = NA, dim= c(12, dim(ph_monpol)[2],2))

joint_results$upper_int5 <- array(data = NA, dim= c(12, dim(ph_monpol_upper_int5)[2],2))
joint_results$lower_int5 <- array(data = NA, dim= c(12, dim(ph_monpol_upper_int5)[2],2))


# standardize the impact effect
index_monpol_ph <- 1
index_monpol <- 2
std_par1 <- ph_monpol[index_monpol_ph,1,1]/0.25
std_par2 <- h_monpol[index_monpol,1,1]/0.25
std_par3 <- proxy_monpol[index_monpol,1]/0.25


joint_results$imp_rep[1:4,,] <- ph_monpol/std_par1
joint_results$imp_rep[5:8,,] <- h_monpol/std_par2 
joint_results$imp_rep[9:12,,] <- proxy_monpol/std_par3


joint_results$upper_int5[1:4,,] <- ph_monpol_upper_int5/std_par1 
joint_results$upper_int5[5:8,,] <- h_monpol_upper_int5/std_par2  
joint_results$upper_int5[9:12,,] <- proxy_mon_upper_int5/std_par3  
joint_results$lower_int5[1:4,,] <- ph_monpol_lower_int5/std_par1
joint_results$lower_int5[5:8,,] <- h_monpol_lower_int5/std_par2  
joint_results$lower_int5[9:12,,] <- proxy_mon_lower_int5/std_par3  

# Now change the order of the variables for the plot
new_order_vars = c(1,2,3,4,6,5,7,8,10,9,11,12)
joint_results$imp_rep = joint_results$imp_rep[new_order_vars,,] 
joint_results$upper_int5 = joint_results$upper_int5[new_order_vars,,] 
joint_results$lower_int5 = joint_results$lower_int5[new_order_vars,,] 
stand_fac = stand_fac[c(2,1,3,4)]


shock_names <- c("MP Shock in Heteroskedastic Proxy-VAR"," MP Shock in heteroskedastic VAR","MP Shock in Standard Proxy-VAR")

plot_impulse_fig3(title="figure3",results_array=joint_results,int= 95, standardize=TRUE, normalize_impact = c(NA,1,NA,NA),  shaded = TRUE, axis_fix=FALSE, horizon=spec$horizon+1, trans_code =code[1:4], eps=TRUE, data_names=names, shock_names=shock_names , path=".")
