rm(list = ls()) # To clear all
setwd("D:/het_instrument_max/estimation/main")
load("C:/Users/Max/Dropbox/Proxy_IH/QE_cond_accept/Code/results.RData")
spec$restric <-  "ph-var"
machine <-  "pc"
source("./general/plot_vardec.R")
source("./general/new_order.R")
source("./general/turn_imp_rep.R")
 turn_vec <- 4 # change sign of impulse response and shock series of respective shock
ph_var <- turn_imp_rep(ph_var, turn_vec, spec)
rm(turn_vec)
 new_order_shocks <- c(4,1,3,2,5) # change order of shocks
 new_order_vars <- c(2,1,3,4,5) # change order of vars
if (!exists("new_order")){new_order <- c(1:K)}
ph_var <- new_ordering(ph_var, new_order_shocks,new_order_vars)

results_list <- ph_var
model_name <- "ph_var"
ph_var <- results_list
  
new_order_fac <- new_order_shocks[1:(K-1)] # This is needed for the destandardization of the impulse responses
new_order_shocks <- c(1:K)
if (exists("turn_vec")){
  results_list <- turn_imp_rep(results_list, turn_vec, spec)
}  
save_path_model <- "./results/test/"
if (!dir.exists(save_path_model)){
  dir.create(save_path_model, recursive=TRUE) 
}

########################## Figure 2: PLOT (K-1)x(K-1) IMPULSE RESPONSE OF ALL SHOCKS FOR ONE MODEL (I.E. REMOVE THE INSTRUMENT) ###############

S <- (K*K)-((K-1)*(K-1))

results_list_cut <- results_list
results_list_cut$imp_rep <- array(NA, dim = c(dim(results_list$imp_rep)[1]-S, dim(results_list$imp_rep)[2:3]))
results_list_cut$variance_decomp <- array(NA, dim = c(dim(results_list$imp_rep)[1]-S, dim(results_list$imp_rep)[2:3]))

results_list_cut$imp_rep_cum <- array(NA, dim = c(dim(results_list$imp_rep_cum)[1]-S, dim(results_list$imp_rep_cum)[2:3]))
results_list_cut$upper_int5 <- array(NA, dim = c(dim(results_list$upper_int5)[1]-S, dim(results_list_cut$upper_int5)[2:3]))
results_list_cut$lower_int5 <- array(NA, dim = c(dim(results_list$upper_int5)[1]-S, dim(results_list_cut$upper_int5)[2:3]))

results_list_cut$variance_decomp <- results_list$variance_decomp[,-K,-K,]
results_list_cut$imp_rep <- results_list$imp_rep[-c(K,2*K,3*K,4*K,4*K + (1:K)),,]
results_list_cut$imp_rep_cum <- results_list$imp_rep_cum[-c(K,2*K,3*K,4*K,4*K + (1:K)),,]
results_list_cut$upper_int5 <- results_list$upper_int5[-c(K,2*K,3*K,4*K,4*K + (1:K)),,]
results_list_cut$lower_int5 <- results_list$lower_int5[-c(K,2*K,3*K,4*K,4*K + (1:K)),,]

results_list_cut$upper_int5_cum <- results_list$upper_int5_cum[-c(K,2*K,3*K,4*K,4*K + (1:K)),,]
results_list_cut$lower_int5_cum <- results_list$lower_int5_cum[-c(K,2*K,3*K,4*K,4*K + (1:K)),,]


################ NAMES OF SHOCKS AND ORDER THE IMPULSE RESPONSES ###################

shock_names <- c("Monetary Policy Shock","Demand Shock","Supply Shock", "Cost-Push Shock")
names <- c("Fed Funds (pp)","Industrial Prod. (%)",  "Consumer Prices (%)", "Commodity Prices (%)") 
names2 <- c("Fed Funds","Industrial Prod.",  "Inflation", "Commod. Prices") 

save_path_model <- "./results/test/figure2"
K <- 4

machine <- "pc" 
source("./general/organization_code/load_packages.R")
library(grid)
library(ggplot2)
source("./general/source.R")
sourceFolder("./general", FALSE, FALSE)
sourceFolder("../ms_switch", FALSE, FALSE)
set.seed(4673590)
plot_impulse_ggplot_stdadj(title="PHVAR-IRF-destandardized",results_array=results_list_cut,int= 95, standardize=TRUE, normalize_impact = c(1,NA,NA,NA), stand_fac = stand_fac[new_order_vars[1:K]], shaded = TRUE, axis_fix=FALSE,horizon=spec$horizon+1, trans_code =code[1:K], eps=TRUE, data_names=names, shock_names=shock_names , path=save_path_model, order=new_order_fac)

####################### Figure 3: ALL MONETARY POLICY IN ONE PLOT ###################################################

proxy_monpol <- pr_var$imp_rep[-5,] 
proxy_mon_upper_int5 <- pr_var$upper_int5[-5,]
proxy_mon_lower_int5 <- pr_var$lower_int5[-5,]

mon_pol_index_ph <- c(1:4)
ph_monpol <- ph_var$imp_rep[mon_pol_index_ph,,]
ph_monpol_upper_int5 <- ph_var$upper_int5[mon_pol_index_ph,,]
ph_monpol_lower_int5 <- ph_var$lower_int5[mon_pol_index_ph,,]

new_order = c(1,2,3,4,5)
mon_pol_index_h <- c(16:19)
h_monpol <- h_var$imp_rep[mon_pol_index_h,,]  
h_monpol_upper_int5 <- h_var$upper_int5[mon_pol_index_h,,]
h_monpol_lower_int5 <- h_var$lower_int5[mon_pol_index_h,,]

joint_results <- list()
joint_results$imp_rep <- array(data = NA, dim= c(12, dim(ph_monpol)[2],2))

joint_results$upper_int5 <- array(data = NA, dim= c(12, dim(ph_monpol_upper_int5)[2],2))
joint_results$lower_int5 <- array(data = NA, dim= c(12, dim(ph_monpol_upper_int5)[2],2))


# standardize the impact effect
index_monpol_ph <- 1
index_monpol <- 2
std_par1 <- ph_monpol[index_monpol_ph,1,1]/0.25
std_par2 <- h_monpol[index_monpol,1,1]/0.25
std_par3 <- proxy_monpol[index_monpol,1]/0.25


joint_results$imp_rep[1:4,,] <- ph_monpol/std_par1
joint_results$imp_rep[5:8,,] <- h_monpol/std_par2 
joint_results$imp_rep[9:12,,] <- proxy_monpol/std_par3


joint_results$upper_int5[1:4,,] <- ph_monpol_upper_int5/std_par1 
joint_results$upper_int5[5:8,,] <- h_monpol_upper_int5/std_par2  
joint_results$upper_int5[9:12,,] <- proxy_mon_upper_int5/std_par3  
joint_results$lower_int5[1:4,,] <- ph_monpol_lower_int5/std_par1
joint_results$lower_int5[5:8,,] <- h_monpol_lower_int5/std_par2  
joint_results$lower_int5[9:12,,] <- proxy_mon_lower_int5/std_par3  

# Now change the order of the variables for the plot
new_order_vars = c(1,2,3,4,6,5,7,8,10,9,11,12)
joint_results$imp_rep = joint_results$imp_rep[new_order_vars,,] 
joint_results$upper_int5 = joint_results$upper_int5[new_order_vars,,] 
joint_results$lower_int5 = joint_results$lower_int5[new_order_vars,,] 
stand_fac = stand_fac[c(2,1,3,4)]

library(gridExtra)
library(grid)
library(ggplot2)
library(lemon)

shock_names <- c("MP Shock in Heteroskedastic Proxy-VAR"," MP Shock in heteroskedastic VAR","MP Shock in Standard Proxy-VAR")

names <- c("Fed Funds (pp)","Industrial Prod. (%)",  "Consumer Prices (%)", "Commodity Prices (%)") 
save_path_model <- "./results/test/figure3"
sourceFolder("./general/", FALSE, FALSE)
plot_impulse_ggplot_figure3(title="Comp_models3",results_array=joint_results,int= 95, standardize=TRUE, normalize_impact = c(NA,1,NA,NA),  shaded = TRUE, axis_fix=FALSE, horizon=spec$horizon+1, trans_code =code[1:4], eps=TRUE, data_names=names, shock_names=shock_names , path=save_path_model)

