plot_impulse_fig2 <- function(title,results_array, int , standardize=TRUE, normalize_impact = c(), stand_fac =c(), shaded = TRUE, axis_fix =FALSE, horizon, trans_code, eps=TRUE, data_names, shock_names, path, order){
  K = length(shock_names)
  new_order_all <- c()
  for (j in new_order[1:length(shock_names)]){
    new_order_all <- c(new_order_all,seq(j*K-K+1,j*K))
  }
  # if variables of VAR have been standardized this multiplies the IRF with the respective value to get back IRFs in non-standardized ways
  if (standardize == TRUE){
    if(!is.null(stand_fac)){
      # Destandardize all IRFS using stand_fac
      for (i in 1:(K*K)){
        jj=i%%K
        if (jj==0){jj=K}
        results_array$imp_rep[i,,] <- results_array$imp_rep[i,,]*stand_fac[jj]
        results_array$upper_int1[i,,] <- results_array$upper_int1[i,,]*stand_fac[jj]
        results_array$lower_int1[i,,] <- results_array$lower_int1[i,,]*stand_fac[jj]
        results_array$upper_int5[i,,] <- results_array$upper_int5[i,,]*stand_fac[jj]
        results_array$lower_int5[i,,] <- results_array$lower_int5[i,,]*stand_fac[jj]
        results_array$upper_int10[i,,] <- results_array$upper_int10[i,,]*stand_fac[jj]
        results_array$lower_int10[i,,] <- results_array$lower_int10[i,,]*stand_fac[jj]
        results_array$upper_int68[i,,] <- results_array$upper_int68[i,,]*stand_fac[jj]
        results_array$lower_int68[i,,] <- results_array$lower_int68[i,,]*stand_fac[jj]
        if (jj != 1){
          results_array$imp_rep[i,,] <- results_array$imp_rep[i,,]*100
          results_array$upper_int1[i,,] <- results_array$upper_int1[i,,]*100
          results_array$lower_int1[i,,] <- results_array$lower_int1[i,,]*100
          results_array$upper_int5[i,,] <- results_array$upper_int5[i,,]*100
          results_array$lower_int5[i,,] <- results_array$lower_int5[i,,]*100
          results_array$upper_int10[i,,] <- results_array$upper_int10[i,,]*100
          results_array$lower_int10[i,,] <- results_array$lower_int10[i,,]*100
          results_array$upper_int68[i,,] <- results_array$upper_int68[i,,]*100
          results_array$lower_int68[i,,] <- results_array$lower_int68[i,,]*100 
        }
      }
      # Normalize impact
      if (!is.null(normalize_impact)){
        for (i in 1:K){
          if(!is.na(normalize_impact[i])){
            xx = normalize_impact[i]/results_array$imp_rep[seq(1,K*K,(K+1))[i],1,1]
            results_array$imp_rep[seq((i-1)*K+1,(i)*K,1),,]  = results_array$imp_rep[seq((i-1)*K+1,(i)*K,1),,]*xx
            results_array$upper_int1[seq((i-1)*K+1,(i)*K,1),,] = results_array$upper_int1[seq((i-1)*K+1,(i)*K,1),,]*xx
            results_array$lower_int1[seq((i-1)*K+1,(i)*K,1),,] = results_array$lower_int1[seq((i-1)*K+1,(i)*K,1),,]*xx
            results_array$upper_int5[seq((i-1)*K+1,(i)*K,1),,] = results_array$upper_int5[seq((i-1)*K+1,(i)*K,1),,]*xx
            results_array$lower_int5[seq((i-1)*K+1,(i)*K,1),,] = results_array$lower_int5[seq((i-1)*K+1,(i)*K,1),,]*xx
            results_array$upper_int10[seq((i-1)*K+1,(i)*K,1),,] = results_array$upper_int10[seq((i-1)*K+1,(i)*K,1),,]*xx
            results_array$lower_int10[seq((i-1)*K+1,(i)*K,1),,] = results_array$lower_int10[seq((i-1)*K+1,(i)*K,1),,]*xx
            results_array$upper_int68[seq((i-1)*K+1,(i)*K,1),,] = results_array$upper_int68[seq((i-1)*K+1,(i)*K,1),,]*xx
            results_array$lower_int68[seq((i-1)*K+1,(i)*K,1),,] = results_array$lower_int68[seq((i-1)*K+1,(i)*K,1),,]*xx
          }
        }
      }
    }
  } else {
    std <- 1
  }
  x_ax_lab <- c()
  y_ax_lab <- c(data_names[1:K], rep("", K^2-K))[order(new_order_all)]
  
  shock_names_plots <- c()
  for (n in 1:(length(shock_names))){
    shock_names_plots <- c(shock_names_plots,shock_names[n],rep("", K-1))
  }
  
  # all shock indices ji for new order of shocks
  for (m in 1:spec$states){ 
    # m=1
    counter <- 0  
    plot_list = list()
    if (eps == TRUE){
      title_file <- paste0(path,"/",title,"_state",m,".eps")
    } else {
      title_file <- paste0(path,"/",title,"_state",m,".pdf")
    }
    for (k in new_order_all){
      # k=1
      counter <-  counter +1
      
      # FIX LIMITS of Y-AXIS
      if (axis_fix == TRUE){
        no_ticks <- 6
        if (any(k == c(1,4,7,10,13))){
          y_limit <- c(-0.02, 1.3)
          break_seq <- seq(0,1.25,by=0.25)
          axis_fix_contemp <- TRUE # if false, then the scale is set automatically only for this variable
        } else if (any(k == c(2,5,8,11,14))){
          y_limit <- c(-0.042, 0.012)
          break_seq <- seq(-0.04,0.01,by=0.01)
          axis_fix_contemp <- TRUE # if false, then the scale is set automatically only for this variable
        } else if (any(k == c(3,6,9,12,15))){
          y_limit <- c(-0.025, 0.05)
          break_seq <- seq(-0.04,-0.01,by=0.01)
          axis_fix_contemp <- FALSE # if false, then the scale is set automatically only for this variable
        }
      } else {
        axis_fix_contemp <- FALSE
        no_ticks <- 6
      }
      
      
      if (any(rep(trans_code, K)[k] == c(0,1))){ 
        if (int == 99){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1]/std*std_int, upper = results_array$upper_int1[k,1:horizon,1]/std*std_int, lower = results_array$lower_int1[k,1:horizon,1]/std*std_int)
        } else if (int == 95){
          # plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1]/std*std_int, upper = results_array$upper_int5[k,1:horizon,1]/std*std_int, lower = results_array$lower_int5[k,1:horizon,1]/std*std_int)
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1], upper = results_array$upper_int5[k,1:horizon,1], lower = results_array$lower_int5[k,1:horizon,1])
        } else if (int == 90){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1]/std*std_int, upper = results_array$upper_int10[k,1:horizon,1]/std*std_int, lower = results_array$lower_int10[k,1:horizon,1]/std*std_int)
        } else if (int == 68){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1]/std*std_int, upper = results_array$upper_int68[k,1:horizon,1]/std*std_int, lower = results_array$lower_int68[k,1:horizon,1]/std*std_int)
        } else if (int == FALSE){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1]/std*std_int)
        }
      } else if (any(rep(trans_code, K)[k] == c(2,3))) {
        if (int == 99){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep_cum[k,1:horizon,1]/std*std_int, upper = results_array$upper_int1_cum[k,1:horizon,1]/std*std_int, lower = results_array$lower_int1_cum[k,1:horizon,1]/std*std_int)
        } else if (int == 95){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep_cum[k,1:horizon,1]/std*std_int, upper = results_array$upper_int5_cum[k,1:horizon,1]/std*std_int, lower = results_array$lower_int5_cum[k,1:horizon,1]/std*std_int)
        } else if (int == 90){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep_cum[k,1:horizon,1]/std*std_int, upper = results_array$upper_int10_cum[k,1:horizon,1]/std*std_int, lower = results_array$lower_int10_cum[k,1:horizon,1]/std*std_int)
        } else if (int == 68){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep_cum[k,1:horizon,1]/std*std_int, upper = results_array$upper_int68_cum[k,1:horizon,1]/std*std_int, lower = results_array$lower_int68_cum[k,1:horizon,1]/std*std_int)
        } else if (int ==FALSE){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep_cum[k,1:horizon,1]/std*std_int)
        }
      }
      
      g <- ggplot(data=plot_data, aes(x=horizon,y=imp_rep)) + geom_line(aes(x=horizon,y=imp_rep), colour="black",size=.8) 
      # BANDS SHADED OR DOTTED LINES?
      if (shaded == TRUE){
        g <- g + geom_ribbon(aes(ymax=upper, ymin=lower), alpha=1/5) + scale_fill_manual("",values="grey10")
        
      } else if (!int == FALSE){
        g <- g + geom_line(data = plot_data, aes(x = horizon, y =upper), colour="black",linetype=5,size=.75)
        g <- g + geom_line(data = plot_data, aes(x = horizon, y =lower), colour="black",linetype=5,size=.75)
      }
      g <- g + theme_bw() 
      g <- g + ggtitle(shock_names_plots[k]) + theme(plot.title = element_text(hjust = 0.5))
      g <- g +  theme(panel.grid.major = element_blank(), panel.grid.minor = element_blank(),legend.position="bottom", axis.title.y = element_text(face="bold"))
      # + scale_y_continuous(breaks = seq(0, ceiling(max(input$data)*10)/10, .2) ,expand=expand_scale(mult = c(0, .02)))
      g <- g + geom_hline(yintercept = 0,linetype="dashed") 
      if (axis_fix_contemp ==TRUE){
        # g <- g + scale_y_continuous(limits=c(y_limit[1], y_limit[2]), breaks = round(seq(round(y_limit[1],decimals), round(y_limit[2],decimals), length.out = no_ticks),decimals))
        g <- g + scale_y_continuous(limits=c(y_limit[1], y_limit[2]), breaks = break_seq)
      } else{
        g <- g + scale_y_continuous(breaks = trans_breaks(identity, identity, n = no_ticks))
      }
      
      g <- g + labs(y = y_ax_lab[k], x=x_ax_lab[k])
      g <-  ggplotGrob(g)
      plot_list[[counter]] <- g   
      
    } # end of loop through imp rep
    #  Plot the list and save
    # to align the plots all to have the same size
    g <-  do.call(rbind, c(plot_list, size="first"))
    g$widths = do.call(unit.pmax, lapply(plot_list, "[[", "widths"))
    for (counter in 1:(K*(length(shock_names)))){
      plot_list[[counter]]$widths <- g$widths
    }
    out_plot <- do.call("grid.arrange", c(plot_list, nrow=K, as.table = FALSE))
    
    if (eps == TRUE){
      ggsave(title_file,  plot = out_plot, width=30, height=20,units = "cm",device=cairo_ps)
    } else {
      ggsave(title_file,  plot = out_plot, width=22, height=18,units = "cm", device="pdf")
    }
  } # end loop m, the states
  
} # end function 
# x11 = function (...) grDevices::x11(...,type='cairo')
# 
