plot_impulse_fig3 <- function(title,results_array, int , standardize=TRUE,normalize_impact = c(),  shaded = TRUE, axis_fix =FALSE, horizon, trans_code, eps=TRUE, data_names, shock_names, path){
  
  nn = length(data_names)
  K = nn
  kk = dim(results_array$imp_rep)[[1]]/nn 
  new_order_all <- c()
  for (j in new_order[1:length(shock_names)]){
    new_order_all <- c(new_order_all,seq(j*K-K+1,j*K))
  }
  # if variables of VAR have been standardized this multiplies the IRF with the respective value to get back IRFs in non-standardized ways
  if (standardize == TRUE){
    if(!is.null(stand_fac)){
      # Destandardize all IRFS using stand_fac
      for (i in 1:nn){
        same_var = seq(i,((kk)*nn),nn)
        results_array$imp_rep[same_var,,] <- results_array$imp_rep[same_var,,]*stand_fac[i]
        results_array$upper_int5[same_var,,] <- results_array$upper_int5[same_var,,]*stand_fac[i]
        results_array$lower_int5[same_var,,] <- results_array$lower_int5[same_var,,]*stand_fac[i]
        if (i != 1){
          results_array$imp_rep[same_var,,] <- results_array$imp_rep[same_var,,]*100
          results_array$upper_int5[same_var,,] <- results_array$upper_int5[same_var,,]*100
          results_array$lower_int5[same_var,,] <- results_array$lower_int5[same_var,,]*100
        }
      }
      # Normalize impact
      if (!is.null(normalize_impact)){
        
        x1 = normalize_impact[2]/results_array$imp_rep[1,1,1]
        results_array$imp_rep[1:4,,]  = results_array$imp_rep[1:4,,]*x1
        results_array$upper_int5[1:4,,] = results_array$upper_int5[1:4,,]*x1
        results_array$lower_int5[1:4,,] = results_array$lower_int5[1:4,,]*x1
        
        x2 = normalize_impact[2]/results_array$imp_rep[5,1,1]
        results_array$imp_rep[5:8,,]  = results_array$imp_rep[5:8,,]*x2
        results_array$upper_int5[5:8,,] = results_array$upper_int5[5:8,,]*x2
        results_array$lower_int5[5:8,,] = results_array$lower_int5[5:8,,]*x2
        
        if ((nn*kk)>8){
          x3 = normalize_impact[2]/results_array$imp_rep[9,1,1]
          results_array$imp_rep[9:12,,]  = results_array$imp_rep[9:12,,]*x3
          results_array$upper_int5[9:12,,] = results_array$upper_int5[9:12,,]*x3
          results_array$lower_int5[9:12,,] = results_array$lower_int5[9:12,,]*x3
        }
      }
    }
  } else {
    std <- 1
  }
  
  x_ax_lab <- c()
  y_ax_lab <- c(data_names[1:K], rep("", K^2-K))[order(new_order_all)]
  
  shock_names_plots <- c()
  for (n in 1:(length(shock_names))){
    shock_names_plots <- c(shock_names_plots,shock_names[n],rep("", K-1))
  }
  
  # all shock indices ji for new order of shocks
  for (m in 1:spec$states){ 
    counter <- 0  
    plot_list = list()
    if (eps == TRUE){
      title_file <- paste0(path,"/",title,"_state",m,".eps")
    } else {
      title_file <- paste0(path,"/",title,"_state",m,".pdf")
    }
    for (k in 1:(nn*kk)){
      counter <-  counter +1
      
      # FIX LIMITS of Y-AXIS
      if (axis_fix == TRUE){
        if (any(k == c(1,4,7))){
          y_limit <- c(-1.2, 0.25)
        } else if (any(k == c(2,5,8))){
          y_limit <- c(-0.1, .5)
        } else if (any(k == c(3,6,9))){
          y_limit <- c(-0.025, 0.05)
        }
      }
      ###
      std = 1
      ###
      if (any(rep(trans_code, K)[k] == c(0,1))){ 
        if (int == 99){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1]/std, upper = results_array$upper_int1[k,1:horizon,1]/std, lower = results_array$lower_int1[k,1:horizon,1]/std)
        } else if (int == 95){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1]/std, upper = results_array$upper_int5[k,1:horizon,1]/std, lower = results_array$lower_int5[k,1:horizon,1]/std)
        } else if (int == 90){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1]/std, upper = results_array$upper_int10[k,1:horizon,1]/std, lower = results_array$lower_int10[k,1:horizon,1]/std)
        } else if (int == 68){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1]/std, upper = results_array$upper_int68[k,1:horizon,1]/std, lower = results_array$lower_int68[k,1:horizon,1]/std)
        } else if (int == FALSE){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep[k,1:horizon,1]/std)
        }
      } else if (any(rep(trans_code, K)[k] == c(2,3))) {
        if (int == 99){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep_cum[k,1:horizon,1]/std, upper = results_array$upper_int1_cum[k,1:horizon,1]/std, lower = results_array$lower_int1_cum[k,1:horizon,1]/std)
        } else if (int == 95){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep_cum[k,1:horizon,1]/std, upper = results_array$upper_int5_cum[k,1:horizon,1]/std, lower = results_array$lower_int5_cum[k,1:horizon,1]/std)
        } else if (int == 90){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep_cum[k,1:horizon,1]/std, upper = results_array$upper_int10_cum[k,1:horizon,1]/std, lower = results_array$lower_int10_cum[k,1:horizon,1]/std)
        } else if (int == 68){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep_cum[k,1:horizon,1]/std, upper = results_array$upper_int68_cum[k,1:horizon,1]/std, lower = results_array$lower_int68_cum[k,1:horizon,1]/std)
        } else if (int ==FALSE){
          plot_data <- data.frame(horizon = c(0:(horizon-1)), imp_rep = results_array$imp_rep_cum[k,1:horizon,1]/std)
        }
      }
      
      g <- ggplot(data=plot_data, aes(x=horizon,y=imp_rep)) + geom_line(aes(x=horizon,y=imp_rep), colour="black",size=.8) 
      # BANDS SHADED OR DOTTED LINES?
      if (shaded == TRUE){
        g <- g + geom_ribbon(aes(ymax=upper, ymin=lower), alpha=1/5) + scale_fill_manual("",values="grey10")
        
      } else if (!int == FALSE){
        g <- g + geom_line(data = plot_data, aes(x = horizon, y =upper), colour="black",linetype=5,size=.75)
        g <- g + geom_line(data = plot_data, aes(x = horizon, y =lower), colour="black",linetype=5,size=.75)
      }
      g <- g + theme_bw() 
      g <- g + ggtitle(shock_names_plots[k]) + theme(plot.title = element_text(hjust = 0.5))
      g <- g +  theme(panel.grid.major = element_blank(), panel.grid.minor = element_blank(),legend.position="bottom", axis.title.y = element_text(face="bold"))
      # + scale_y_continuous(breaks = seq(0, ceiling(max(input$data)*10)/10, .2) ,expand=expand_scale(mult = c(0, .02)))
      g <- g + geom_hline(yintercept = 0,linetype="dashed") 
      if (axis_fix ==TRUE){
        g <- g + ylim(low=y_limit[1], high=y_limit[2])
      }
      g <- g + labs(y = y_ax_lab[k], x=x_ax_lab[k])
      g <-  ggplotGrob(g)
      plot_list[[counter]] <- g   
      
    } # end of loop through imp rep
    #  Plot the list and save
    # to align the plots all to have the same size
    g <-  do.call(rbind, c(plot_list, size="first"))
    g$widths = do.call(unit.pmax, lapply(plot_list, "[[", "widths"))
    for (counter in 1:(K*(length(shock_names)))){
      plot_list[[counter]]$widths <- g$widths
    }
    
    out_plot <- do.call("grid.arrange", c(plot_list, nrow=K, as.table = FALSE))
    
    if (eps == TRUE){
      ggsave(title_file,  plot = out_plot, width=30, height=20,units = "cm",device=cairo_ps)
    } else {
      ggsave(title_file,  plot = out_plot, width=22, height=18,units = "cm", device="pdf")
    }
  } # end loop m, the states
  
} # end function 