plot_state_prob <- function(state_prob,  recessions.trim, uncert.trim, date_series, path){
  K <- dim(state_prob)[2] 
  if (!is.null(uncert.trim)){
    uncert.trim.data <- uncert.trim[[1]][,1:2]
    label_names <- uncert.trim[[1]][,3]
  }  
  # Erase first observation of state prob (CHECK THIS!)
  state_prob <- state_prob[-1,]
  length_dif <- length(date_series) - dim(state_prob)[1]
  date_series <- date_series[-c(1:length_dif)]
  
  pdf(paste0(path, "figure1.pdf", sep=""))
  on.exit(dev.off())
  
  g <- list()
  for (i in 1:K){
    ser <-  state_prob[,i]
    plot_data <-  data.frame(date=as.Date(paste(date_series,"-01", sep="")), ser)
    if (!is.null(recessions.trim)){
      # g[[i]] <- ggplot()  + geom_rect(data=uncert.trim.data, aes(xmin=event_start, xmax=event_end, ymin=-Inf, ymax=+Inf), fill='blue', alpha=0.4)
      g[[i]] <- ggplot() + geom_rect(data=recessions.trim, aes(xmin=Peak, xmax=Trough, ymin=-Inf, ymax=+Inf), fill='grey', alpha=0.8)
      if (!is.null(uncert.trim)){
        g[[i]] <- g[[i]] + geom_rect(data=uncert.trim.data, aes(xmin=event_start, xmax=event_end, ymin=-Inf, ymax=+Inf), fill='blue', alpha=0.8)
        g[[i]] <- g[[i]] + geom_text(aes(x = event_start, y=1.01, angle = 90,label = label_names),
                                     data = uncert.trim.data,
                                     size = 1.5, vjust = -0.2, hjust = 0, nudge_y=0, nudge_x = 0, check_overlap = TRUE)
      }  
    } else if (is.null(recessions.trim)){
      g[[i]] <- ggplot()
      
      if (!is.null(uncert.trim)){
        g[[i]] <- g[[i]] + geom_rect(data=uncert.trim.data, aes(xmin=event_start, xmax=event_end, ymin=-Inf, ymax=+Inf), fill='blue', alpha=0.8)
        g[[i]] <- g[[i]] + geom_text(aes(x = event_start, y=Inf, angle = 90,label = label_names),
                                     data = uncert.trim.data,
                                     size = 1.5, vjust = -0.2, hjust = 0, nudge_y=0, nudge_x = 0, check_overlap = TRUE)
      }
    }
    g[[i]] <- g[[i]]+ geom_line(data=plot_data, aes(x=date, y=ser)) + theme_bw() 
    # Fill the area below the lines
    g[[i]] <- g[[i]]+ geom_ribbon(data=subset(plot_data, date > "1960-07-01"),
                                  aes(x=date,ymax=ser),ymin=0,fill="grey", alpha=0.2)
    
    
    g[[i]] <-  g[[i]] + xlab("Time") + ylab("")
    g[[i]] <-  g[[i]] + theme(axis.title.x = element_text(size = 8, angle = 00))
    g[[i]] <-  g[[i]] + scale_y_continuous(breaks=pretty_breaks(n=5))  
    g[[i]] <-  g[[i]] + scale_x_date(breaks=pretty_breaks(n=10))
    g[[i]] <-  g[[i]] + ggtitle(paste0("Probability State ",i))+ theme(plot.title = element_text(size=10,lineheight=.4, face="bold", hjust=0.5)) + coord_cartesian(ylim=c(0.05,1.0))
    
  }  
  
  n <- length(g)
  nCol <- K
  nRow <- K
  do.call("grid.arrange", c(g, nrow=nRow))
}
