portmanteau_func <- function(u_est,K, Samp, spec, h=16){
  # Portmanteau test -  Lütkepohl page 159 ff.
  
  #generate the (sum of) the auto_covariance matrices
  U <-  t(u_est) 
  dim(u_est)
  C_0 <- (1/(Samp-spec$lag))*U%*%t(U)
  D <- diag(sqrt(diag(C_0)))
  
  F_all <- c()
  for (i in 1:h){
    empty <- matrix(0, i, Samp-spec$lag-i )
    t_empty <- matrix(0, Samp-spec$lag, i)
    idn <- diag(1, (Samp-spec$lag-i), (Samp-spec$lag-i))
    F_mat <- rbind(empty, idn)
    F_mat <- cbind(F_mat,t_empty)
    F_all <- cbind(F_all, F_mat)
  }
  
  C_h <- U%*%F_all%*%(kronecker(diag(h), t(U)))/(Samp-spec$lag)
  
  tr_c_prod <- c()
  tr_c_prod_mod <- c()
  for (i in 1:h){
    C_i <- C_h[,(K*(i-1)+1):(K*i)]
    tr_c_prod[i] <- matTrace(t(C_i)%*%solve(C_0)%*%C_i%*%solve(C_0))
    tr_c_prod_mod[i] <- 1/(Samp-spec$lag-i)*matTrace(t(C_i)%*%solve(C_0)%*%C_i%*%solve(C_0))
  }  
  Q_h <- (Samp-spec$lag)* sum(tr_c_prod)
  Q_h_mod <- (Samp-spec$lag)^2* sum(tr_c_prod_mod)
  
  p <- 1-pchisq(Q_h, df=((K)^2*(h-spec$lag) ))
  p_mod <- 1-pchisq(Q_h_mod, df=((K)^2*(h-spec$lag) ))
  
  out <- list(port_p =p, port_p_mod = p_mod)
  return(out)
} # end of function