## finds all .R and .r files within a folder and sources them
sourceFolder <- function(folder, recursive,which_envir) { 
  files <- list.files(folder, pattern = "[.][rR]$", 
                      full.names = TRUE, recursive = recursive)
  if (!length(files))
    stop(simpleError(sprintf('No R files in folder "%s"', folder)))
  src <- invisible(lapply(files, source, local=which_envir))
  message(sprintf('%s files sourced from folder "%s"', length(src), folder))
}
