start_rows <-  function(spec, instr_sel =c(), fake_instr_period = FALSE, by_date=FALSE){
  # by_date: Enter a a period in the form list(start ="1960-07", end="1990-07") to specfiy estimation period.
  # If both, start and end are defined, all other specifications are overridden, if only start or end are defined, then the instrument period is faked for the missing period
  # fake_instr_period: Fakes the period for which the instruments exists as estimation period. 
  # To undo this set fake_instrument_period and spec$instrument to FALSE
  
  # check if "by date" is specified
  if (is.null(by_date) & (fake_instr_period == TRUE) | !length(by_date)==2){
    # plain-VAR without instrument
    if ( (!(spec$instrument) || is.null(instr_sel)) & (fake_instr_period == FALSE) ) {
      out <- list(data = c(1:523), proxy = 1:523)  
      # Fake instrument period for different instruments
    } else if (!is.null(instr_sel) && ((spec$instrument) || fake_instr_period == TRUE)) {
      if (instr_sel == c(2)){
        out <- list(data = c(240:523), proxy = 240:523)  
      } else if (instr_sel == c(3)){
        out <- list(data = c(254:523), proxy = 254:523)  
      } else if (instr_sel == c(4)){
        out <- list(data = c(182:523), proxy = 182:523)  
      } else if (instr_sel == c(5)){
        out <- list(data = c(182:523), proxy = 182:523)
      } else if (instr_sel == c(6)){
        out <- list(data = c(182:523), proxy = 182:523)
      } else if (instr_sel == c(7)){
        out <- list(data = c(255:523), proxy = 255:493)
      } else if (instr_sel == c(8)){
        out <- list(data = c(128:523), proxy = 128:523)
      } else if (instr_sel == c(9)){
        out <- list(data = c(254:523), proxy = 254:523)
      } else if (instr_sel == c(10)){
        out <- list(data = c(2:469), proxy = 2:469)
      } else if (instr_sel == c(11)){
        out <- list(data = c(254:469), proxy = 254:469)
      } else if (instr_sel == c(12)){
        out <- list(data = c(314:469), proxy = 314:469)
      }
      
    }
    # missing end or start date
    if ("end" %in% names(by_date)){
      end <-  by_date$end
      start_all <- "1969-01-31" # THE END DAYS OF THE MONTHS HAVE TO BE CORRECT --> MONTHS WITH 30 or 31 DAYS
      end_all <-  "2012-06-30"
      date_all <-  substr(as.Date(as.yearmon(seq(as.numeric(as.yearmon(start_all)), as.numeric(as.yearmon(end_all)), 1/12))),1,7)
      start_row_proxy <- out[[2]][1] 
      start_row_data <- out[[1]][1] 
      end_row_data <- 1 + which(grepl(end, date_all)) 
      end_row_proxy <- 1 + which(grepl(end, date_all))  
      out <- list(data = seq(start_row_data,end_row_data,1),  proxy = seq(start_row_proxy,end_row_proxy,1))
    } else if ("start" %in% names(by_date)){
      start <-  by_date$start
      start_all <- "1969-01-31" # THE END DAYS OF THE MONTHS HAVE TO BE CORRECT --> MONTHS WITH 30 or 31 DAYS
      end_all <-  "2012-06-30"
      date_all <-  substr(as.Date(as.yearmon(seq(as.numeric(as.yearmon(start_all)), as.numeric(as.yearmon(end_all)), 1/12))),1,7)
      end_row_proxy <- out[[2]][length(out[[2]])] 
      end_row_data <- out[[1]][length(out[[1]])] 
      start_row_data <- 1 + which(grepl(start, date_all)) 
      start_row_proxy <- 1 + which(grepl(start, date_all))  
      out <- list(data = seq(start_row_data,end_row_data,1),  proxy = seq(start_row_proxy,end_row_proxy,1))
    }   
  } else {
    
    start <-  by_date[1]
    end <-  by_date[2]
    start_all <- "1969-01-01" # THE END DAYS OF THE MONTHS HAVE TO BE CORRECT --> MONTHS WITH 30 or 31 DAYS
    end_all <-  "2012-06-30"
    date_all <-  substr(as.Date(as.yearmon(seq(as.numeric(as.yearmon(start_all)), as.numeric(as.yearmon(end_all)), 1/12))),1,7)
    start_row_data <- 1 + which(grepl(start, date_all))
    end_row_data <- 1+ which(grepl(end, date_all)) 
    start_row_proxy <- 1 + which(grepl(start, date_all)) 
    end_row_proxy <- 1 + which(grepl(end, date_all))  
    out <- list(data = seq(start_row_data,end_row_data,1),  proxy = seq(start_row_proxy,end_row_proxy,1))
    
  }    
  return(out)    
}