uni_cov <- function(u_stand, Samp, K, spec, H ){
  # create result arrays
  Q1 <- vector(mode="numeric",length=H)
  p <- vector(mode="numeric",length=H)
  # turn to matrix element
  u_stand <-  as.matrix(u_stand)
  # due to symmetry
  H <- abs(H)  
  # loop through all residuals (univariately)
  psi <- vector(mode="numeric",length=Samp-spec$lag)
  
  for (i in 1:(Samp-spec$lag)){
    psi[i] <-  t(u_stand[i,])%*%u_stand[i,] - (Samp-spec$lag)^-1*  t(c(u_stand))%*%c(u_stand)
  }
  
  #generate the (sum of) the auto_covariance matrices
  # variance, i.e. gamma(0)
  # gamma0 <- vector(mode="numeric", length=K)
  gamma0 <- (Samp-spec$lag)^-1*t(psi)%*%psi 
  
  # create empty vectors to hold statistics and for calculation
  
  sum_division <- 0
  for (i in 1:H){
    empty <- matrix(0, i, Samp-spec$lag-i )
    t_empty <- matrix(0, Samp-spec$lag, i)
    idn <- diag(1, (Samp-spec$lag-i), (Samp-spec$lag-i))
    F_mat <- rbind(empty, idn)
    F_mat <- cbind(F_mat,t_empty)
    gamma_j <- (Samp-spec$lag)^-1*t(psi)%*%F_mat%*%psi
    division <- (gamma_j/gamma0)^2
    sum_division <- sum_division + division
    Q1[i]  <- (Samp-spec$lag)* sum_division
    p[i] <- 1-pchisq(Q1[i], df=i)
  } # end of loop through i
  
  out <- list(test_Q1 =Q1, p_Q1 = p)
  return(out)
} # end of function