rm(list = ls()) # To clear all
# set path
setwd("D://het_instrument/Code/estimation/main")

# ------------------ Load packages and source functions ------------------
# load packages and source functions
source("./general/organization_code/load_packages.R")
source("./general/source.R")
sourceFolder("./general", FALSE, FALSE)
sourceFolder("../Proxy/", FALSE, FALSE)

set.seed(4673590)
############################################ Proxy VAR ##########################################################
# Reload data, do get new Y and Z matrices
data_sel <-  c(1, 3, 4, 32, 18) # refers to columns in excel sheet: Industrial Production (in logs), Fed Funds Rate, Price index of PCE (in logs), Raw Materials Price index (no transformation)
aug_var <- FALSE
instr_sel = c(1,16) # 3 is GK instrument, 8 is RR instrument, 11 is Miranda-Agrippino, 12 is Nakamura-Steinsson, , 13 is Benanke and Mihov, 14 is Barachian and Crowe, 18 is factor of all instruments
code <- c(0,0,0,1) 
names <- c(data_names(data_sel, 1))
# Lags
lag_length <- 6 # Lag length  
horizon_imp <- 60 # Horizon to be used in impulse responses
# Put all information in spec-list element which is passed to the algorithm below
spec <- list(trend=FALSE,lag=lag_length, horizon=horizon_imp, rep=1000, boot="yes", instrument =TRUE,pos_instr =2, sim=FALSE)
stand=TRUE
source("./general/organization_code/data_prep.R")

spec$restric <- "proxy"
spec$boot <- "yes"

pr_var <- proxy_var(spec = spec, y=y,Z=Z,y_start=y_start, Samp=Samp, K, date_list =date_list)
saveRDS(pr_var, file="pr_var.Rds")
pr_var$f_robust
pr_var$f_test
