Likelihood_all_dep_ins <- function(param, K,Samp, spec, estimation,y, Z,vector_out = FALSE){
  #loop through i runs until end of code almost
  elements <-  numel(param)
  elem_theta <- numel(estimation$Theta)
  logLikVec <-  matrix(NA, (Samp-spec$lag),1)
  B <-  matrix(param[1:(K^2)],K,K)
  Lambda <- rbind(diag(K), diag(param[(K^2 +1):(K^2 +K*(spec$states-1)) ]))
  beta <-  param[(K^2 +K*(spec$states-1)+elem_theta+1):(K^2 +K*(spec$states-1)+elem_theta+length(estimation$beta) )]
  lambda_nu <- param[(K^2 +K*(spec$states-1)+elem_theta+length(estimation$beta)+1 ):(K^2 +K*(spec$states-1)+elem_theta+length(estimation$beta) +spec$states) ]
  
  # Form matrix Sigma of the state-dependent covariance matrices
  Sigma <- matrix(NA, dim(y)[2]*spec$states,dim(y)[2])
  
  if (spec$states == 2){
    for (i in 1:spec$states){
      Sigma[(1+dim(y)[2]*(i-1)):(dim(y)[2]*i),] <- rbind(cbind(B%*%Lambda[(1+K*(i-1)):(K*i),]%*%t(B), c(beta%*%Lambda[((i-1)*K+1):(K*i),][1:length(estimation$beta),1:length(estimation$beta)]%*%t(B[,1:length(estimation$beta)])) ), c(beta%*%Lambda[((i-1)*K+1):(K*i),][1:length(estimation$beta),1:length(estimation$beta)]%*%t(B[,1:length(estimation$beta)]), t(Lambda[((i-1)*K+1):(K*i),][1:length(estimation$beta),1:length(estimation$beta)]%*%beta)%*%beta+lambda_nu[i]) )
    }
  } else if (spec$states == 3){
    Sigma[(1:K),] <- B%*%t(B)
    Sigma[(K+1):(2*K),]<- B%*%diag(param[(K^2+1):(K^2+K)],K,K)  %*%t(B)
    Sigma[(2*K+1):(3*K),] <- B%*%diag(param[(K^2+K+1):(K^2+2*K)],K,K)  %*%t(B)
  }else if (spec$states == 4){
    Sigma[(1:K),] <- B%*%t(B)
    Sigma[(K+1):(2*K),]<- B%*%diag(param[(K^2+1):(K^2+K)],K,K)  %*%t(B)
    Sigma[(2*K+1):(3*K),] <- B%*%diag(param[(K^2+K+1):(K^2+2*K)],K,K)  %*%t(B)
    Sigma[(3*K+1):(4*K),] <- B%*%diag(param[(K^2+2*K+1):(K^2+3*K)],K,K)  %*%t(B)
  }    
  
  P <- matrix(param[(numel(param)- numel(estimation$P[1:(spec$states-1),]) +1) : numel(param) ]  , (spec$states-1), spec$states)  
  
  for (k in 1:(spec$states-1)){
    for (q in 1:(spec$states)){
      if (P[k,q]>1){
        P[k,q] <- 0.999999999    
      } else if (P[k,q] <= 0){
        P[k,q] <-  0.0000000001      
      } # end if/else if
    } # end of loop through q
  } # end of loop through k 
  
  P_last <-  matrix(1, 1, spec$states)
  for (k in 1:(spec$states-1)){
    P_last <-  P_last - P[k,]
  } # end loop through k
  P <- rbind(P, P_last)
  u_est <- residuals4(y, param[(elements-elem_theta-numel(estimation$P[(1:(spec$states-1)),])- numel(estimation$beta)-numel(estimation$lambda_nu)  +1):(elements -numel(estimation$P[(1:(spec$states-1)),]) - numel(estimation$beta)-numel(estimation$lambda_nu))],Z,dim(y)[2],spec)
  
  Ksi <- estimation$Ksi
  
  #update conditional density function Eta for changes in parameter values
  Eta <-  matrix(NA, (Samp-spec$lag),spec$states)
  for (j in 1:(Samp-spec$lag)){
    for (position in 1:spec$states){
      sigma <- get_sigma(Sigma,dim(y)[2],position)
      Eta[j,position] <-  (2*pi)^(-K/2)*det(sigma)^-0.5*exp(-0.5*t(u_est[j,])%*%chol2inv(chol(sigma))%*%u_est[j,])
    } # end of loop through position
  }# end of loop through j
  # update state probabilities for the changes in parameter values
  for (q in 2:(Samp-spec$lag +1)){
    Ksi[q,(1:(spec$states))]  <- t( Eta[(q-1),]*(P%*%Ksi[(q-1),(1:spec$states)])/as.numeric( t(spec$const) %*% ( Eta[(q-1),]*(P%*%Ksi[(q-1),(1:spec$states)]))) )
  } # end of loop through q
  # calculate the approximated derivative for each t and each parameter
  for (t in 1:(Samp-spec$lag)){
    logLikVec[t,] <- log(t(P%*%Ksi[t,]) %*% Eta[t,])
  } # end of loop through t
  LogLike <- sum(-logLikVec)  
  
  if (vector_out){
    return(logLikVec)
  } else {
    return(LogLike)
  }
}




