Likelihood_all_lambda <- function(Lambda_param, K,Samp, spec, estimation, B, y, Z, vector_out){
  #loop through i runs until end of code almost
  logLikVec <-  matrix(NA, (Samp-spec$lag),1)
  Sigma <- estimation$Sigma
  Lambda_param <- c(rep(1,K), Lambda_param)
  for (i in 1:spec$states){
    Sigma[(1+K*(i-1)):(K*i),] <- B%*%  diag(Lambda_param[(1+K*(i-1)):(K*i)])%*%t(B)
  }
  
  Theta <- estimation$Theta
  u_est <- residuals4(y, Theta, Z, K)
  P <- estimation$P
  Ksi <- estimation$Ksi
  
  #update conditional density function Eta for changes in parameter values
  Eta <-  matrix(NA, (Samp-spec$lag),spec$states)
  for (j in 1:(Samp-spec$lag)){
    for (position in 1:spec$states){
      sigma <- get_sigma(Sigma,K,position)
      Eta[j,position] <-  (2*pi)^(-K/2)*det(sigma)^-0.5*exp(-0.5*t(u_est[j,])%*%chol2inv(chol(sigma))%*%u_est[j,])
    } # end of loop through position
  }# end of loop through j
  # update state probabilities for the changes in parameter values
  for (q in 2:(Samp-spec$lag +1)){
    Ksi[q,(1:(spec$states))]  <- t( Eta[(q-1),]*(P%*%Ksi[(q-1),(1:spec$states)])/as.numeric( t(spec$const) %*% ( Eta[(q-1),]*(P%*%Ksi[(q-1),(1:spec$states)]))) )
  } # end of loop through q
  # calculate the approximated derivative for each t and each parameter
  for (t in 1:(Samp-spec$lag)){
    logLikVec[t,] <- log(t(P%*%Ksi[t,]) %*% Eta[t,])
  } # end of loop through t
  LogLike <- sum(-logLikVec)  
  
  if (vector_out){
    return(logLikVec)
  } else {
    return(LogLike)
  }
}



