LogLike_ms_condml <- function(unknown, Lambda_pos, KsiT, Tm, spec, u_est, Samp, K, lag_length){
  # estimation of all parameters of B (KxK) in first part of matrix unknown, and estimation of parameters of lambda (last column of unknown matrix, K-parameters (diagonal elements))
  unknown_vec <- vector(mode="numeric", length=K^2)
  for (i in 1:(K^2)){
    unknown_vec[i] <- unknown[i]  
  } 
  
  BL <- cbind(matrix(unknown_vec, K, K), Lambda_pos)
  
  #likelihood
  L <- 0
  # help matrix A
  A <- matrix(NA, K*spec$states, K)
  for (position in 1:spec$states){
    A[(1+K*(position-1)):(K*position),] <-  t(matrix(rep(KsiT[2:(Samp-spec$lag+1),position],times=K),(Samp-spec$lag),K)*u_est)%*%u_est
  } # end of position loop through states
  # add up the log-likelihood. Break it up into two parts. The first one is not state specific
  sigma_a <- get_sigma(A,K,1)
  L <- L + (Samp-spec$lag)*log(abs(det(matrix(BL[,(1:K)],K,K))))+0.5*matTrace( solve(t(BL[,(1:K)]))%*%solve(BL[,1:K])%*%sigma_a )
  # in parellel loop for the other states
  for (position in 2:spec$states){
    sigma_a <- as.matrix(A[((1+K*(position-1)):(K*position)), ])
    L <-  L + Tm[1,position]/2*log(det(diag(BL[,(K+position-1)],K,K)))+0.5*matTrace( solve(t(BL[,1:K]))%*%solve(diag(BL[,(K+position-1)],K,K))%*% solve(BL[, (1:K)]) %*%sigma_a )
  }
  
  if(is.na(L) == 0){
    return(L) ;
  }else{
    return(1e25) ;
  }
} # end of function LogLike
