block_boot_data <-  function(s,l,rep, K, Samp, lag_length, u_est, y_start, y_comp, Theta, u_star_array,Z_star_array,y_star_array){
  
  for (n in 1:rep){ #rep
    row_block_mat <-  length(l:(Samp-lag_length))
    # draw rows of block matrix with replacement that are used to construct series of residuals later
    row_draw <- sample(c(1:row_block_mat), ceiling(s), replace = TRUE )    
    
    u_star <- c()
    for (k in 1:K){
      # k=1
      block_resid <- c()
      counter <-  0
      for (i in l:(Samp-lag_length)){
        # i=1
        counter <-  counter + 1
        # matrix with sequences of residuals of length s
        block_resid <- rbind(block_resid, u_est[counter: (l+(counter-1)),k] )
        
      }
      col_means_block <- apply(block_resid, 2, mean)
      block_resid_demean <- sweep(block_resid, 2, col_means_block)
      
      # construct u_star by using the demeaned residuals (with means of the rows of the block matrix)
      u_star <- cbind(u_star,c(t(block_resid_demean[row_draw,]))[1:(Samp-lag_length)])
    }
    
    
    u_star_array[,,n] <- u_star
    # Starting values
    y_star <- matrix(NA, Samp,K)
    # starting values 
    y_star[(1:lag_length),] <- matrix(y_start,lag_length, K)
    for (r in (lag_length+1):Samp){
      for (i in 1:lag_length){
        if (i == 1){
          y_star[r,] <- Theta[,1] + u_star_array[(r-lag_length),,n]
        }
        y_star[r,] <-  y_star[r,]  + t(Theta[, ((i-1)*K+2):((i-1)*K+K+1)]%*% y_star[r-i,])
        
      }  # end of loop throug i
    } # end of loop through r
    
    y_star_lag <- y_lag_cr(y_star, lag_length)$lags
    y_star_array[,,n] <- (y_star[-(1:lag_length),])
    #generate Z matrix with constant
    con <- matrix(1,Samp-lag_length,1)
    y_lag <- y_lag_cr(y_comp, lag_length)$lags
    Z_star_array[,,n] <- cbind(con, y_star_lag)
    # Z_star_array[,,n] <- cbind(con,y_star_lag)
  } # end of loop through n
  out <- list(y_star_array = y_star_array, Z_star_array=Z_star_array)  
  
}

