create_boot_data <-  function(y, y_start, lag_length, spec, Samp, Theta, K, u_est){
  y_comp <- as.matrix(rbind(y_start, y))
  y_star <- matrix(NA, Samp,K)
  y_star[(1:lag_length),] <- matrix(y_start,lag_length, K)
  
  
  # Rademacher distribution
  rade <-   sample(c(-1, 1), size=(Samp-lag_length),replace=TRUE, prob=c(0.5, 0.5))
  u_star <- u_est*rade
  
  # Starting values
  if (spec$trend ==FALSE){
    for (l in (lag_length+1):Samp){ 
      for (i in 1:lag_length){
        if (i == 1){
          y_star[l,] <- Theta[,1] + u_star[(l-lag_length),]
        }
        y_star[l,] <-  y_star[l,]  + t(Theta[, ((i-1)*K+2):((i-1)*K+K+1)]%*% y_star[l-i,])
      }  # end of loop throug i
    } # end of loop through l
    
  } else{
    trend <- seq(1,Samp-lag_length)
    for (l in (lag_length+1):Samp){ 
      for (i in 1:lag_length){
        if (i == 1){
          y_star[l,] <- Theta[,1] + Theta[,2]*trend[l-spec$lag] +  u_star[(l-lag_length),]
        }
        # y_star[l,] <-  y_star[l,]  + t(Theta[, ((i-1)*K+2):((i-1)*K+K+1)]%*% y_comp[l-i,])
        y_star[l,] <-  y_star[l,] + t(Theta[, ((i-1)*K+3):((i-1)*K+K+2)]%*% y_star[l-i,])
        
      }  # end of loop throug i
    } # end of loop through l
  }
  
  #generate Z matrix with constant
  con <- matrix(1,Samp-lag_length,1)
  if (spec$trend==TRUE){
    y_star_lag <- y_lag_cr(y_star, lag_length)$lags
    Z_star <- cbind(con,trend, y_star_lag)
    y_star <- (y_star[-(1:lag_length),])
  } else {
    y_star_lag <- y_lag_cr(y_star, lag_length)$lags
    Z_star <- cbind(con, y_star_lag)
    y_star <- (y_star[-(1:lag_length),])
  }
  
  return(list(y_star = y_star, Z_star = Z_star, u_star = u_star))
}

