minimize_ms <- function(KsiT,Samp,K,Tm, Lambda, B, spec, u_est ,Theta){
  
  # Matrix of parameters to maximize <- first B, then in the next columns diag elements of Lambda
  BL <- B
  for (position in 1:(spec$states-1)){
    Lambda_pos <- diag(as.matrix(Lambda[(position*K+1): (K*(position+1)),]))
    BL <- cbind(BL, Lambda_pos)
  }
  
  ################
  # Restrictions #
  ################
  bound <- -1000
  zero_bound <- -0.00001 # cannot be exaclty zero, but little lower, s.t. it doesnt interfere with zero equality constraint
  if (spec$restric =="ph-var" || spec$restric =="invarB" || spec$restric =="invarB-res"){
    if (!spec$restric =="invarB"){
      # Restriction B: Last Column with K-1 zeros
      eq_res_B <- function(unknown) eq_restr_B(unknown,spec, Samp, K)
      BL[1:(K-spec$ins_dim), (K-(spec$ins_dim-1)):K] <- 0
      if (spec$restric =="ph-var"){ # get the zero bound for beta coefficients if the length of beta is < (K-1)
        # BL[K, c(1,3)] <- 0
        BL[(K-(spec$ins_dim-1)):K,(1+spec$lenb):(K-spec$ins_dim)] <- 0
        # BL[K, (1+spec$lenb):(K-1)] <- 0
        lb_help <-  matrix(bound, K,K)
        # lb_help[K,(1+spec$lenb):(K-1)] <- zero_bound
        # lb_help[K,c(1,3)] <- zero_bound
        lb_help[1:(K-spec$ins_dim),(K-(spec$ins_dim-1)):K]  <- zero_bound
        lb_help[(K-(spec$ins_dim-1)):K,(1+spec$lenb):(K-spec$ins_dim)] <- zero_bound
        lb <- c(c(lb_help), rep(0.01,K*(spec$states-1)))
      } else if (!spec$restric =="ph-var"){ # lower bound for all models that are not ph-var and not h-var! (i.e., invarB-res-Models)
        lb <- c(rep(bound, K*(K-spec$ins_dim)), rep(c(rep(zero_bound,(K-spec$ins_dim)),rep(bound, spec$ins_dim)), spec$ins_dim) , rep(0.01,K*(spec$states-1)))
      }
      # lower bound for unrestricted B-Matrix (NO zeros in last column)
    } else if (spec$restric =="invarB") {
      lb <- c(rep(bound, K*K), rep(0.01,K*(spec$states-1)))
    }
    ob_fun <- function(unknown) LogLike_ms(unknown,KsiT,Tm,spec,u_est,Samp,K,spec$lag)
    
    if (spec$restric == "invarB"){
      res <-  solnp(pars=c(BL), fun=ob_fun, LB=lb, control=list(trace=FALSE))
    }
    if (spec$restric == "invarB-res"){
      res <-  solnp(pars=c(BL), fun=ob_fun, LB=lb, eqfun= eq_res_B , eqB=rep(0,spec$ins_dim*(K-spec$ins_dim)), control=list(trace=FALSE))
    }
    if (spec$restric == "ph-var"){
      res <-   solnp(pars=c(BL), fun=ob_fun, LB=lb, eqfun= eq_res_B , eqB=c(rep(0,spec$ins_dim*(K-spec$ins_dim)), rep(0, spec$ins_dim*((K-spec$ins_dim)-spec$lenb))), control=list(trace=FALSE))
    }
    
  } else { # for h-var model (i.e., spec$lenb == 0)
    eq_res_B <- function(unknown) eq_restr_B(unknown,spec, Samp, K)
    BL[(K-(spec$ins_dim-1)):K,1:(K-spec$ins_dim)]  <-  0
    lb_help <-  matrix(bound, K,K)
    lb_help[(K-(spec$ins_dim-1)):K,1:(K-spec$ins_dim)]  <-  zero_bound
    eqB_out <-  rep(0, spec$ins_dim*(K-spec$ins_dim))
    if (spec$restric == "h-var-res"){
      BL[(K-(spec$ins_dim-1)):K,1:(K-spec$ins_dim)]  <-  0
      BL[1:(K-spec$ins_dim),(K-(spec$ins_dim-1)):K]  <-  0
      lb_help[(K-(spec$ins_dim-1)):K,1:(K-spec$ins_dim)]  <-  zero_bound
      lb_help[1:(K-spec$ins_dim),(K-(spec$ins_dim-1)):K]  <- zero_bound
      eqB_out <-  c(eqB_out,rep(0, spec$ins_dim*(K-spec$ins_dim)))
    }
    lb <- c(lb_help, rep(0.01,K*(spec$states-1)))
    ob_fun <- function(unknown) LogLike_ms(unknown,KsiT,Tm,spec,u_est,Samp,K,spec$lag)
    res <-   solnp(pars=c(BL), LB=lb,fun=ob_fun, eqfun=eq_res_B , eqB=eqB_out, control=list(trace=FALSE))
  }
  par <- c(res$pars)
  val <- res$values[length(res$values)]
  out <- list(BL = c(par), val = val)
} # end of function minimize_ms

