minimize_ms_condml <- function(KsiT,Samp,K,Tm, Lambda, B, spec, u_est ,Theta){
  
  # Lambda parameters: in the are the diag elements of Lambda
  Lambda_pos <- c()
  for (position in 1:(spec$states-1)){
    Lambda_pos_help <- diag(as.matrix(Lambda[(position*K+1): (K*(position+1)),]))
    Lambda_pos <- cbind(Lambda_pos, Lambda_pos_help)
  }
  
  ################
  # Restrictions #
  ################
  
  # lb is lower bound for constrained optimization, lbound returns the bound for different number of states and variables
  bound <- -Inf
  zero_bound <- -10^-9# cannot be exaclty zero, but little lower, s.t. it doesnt interfere with zero equality constraint
if (spec$restric =="ph-var" || spec$restric =="invarB" || spec$restric =="invarB-res"){
  if (!spec$restric =="invarB"){
    # Restriction B: Last Column with K-1 zeros
    eq_res_B <- function(unknown) eq_restr_B_condml(unknown, Lambda_pos,spec, Samp, K)
    B[1:(K-1), K] <- 0
    if (spec$restric =="ph-var"){ # get the zero bound for beta coefficients if the length of beta is < (K-1)
      B[K, c(which(abs(B[K,])<10^-10))] <- 0
      lb_help <-  matrix(bound, K,K)
      lb_help[K,c(which(abs(B[K,])<10^-10))] <- zero_bound
      lb_help[1:(K-1),K]  <- zero_bound
      lb <- c(lb_help)
      # lb <- rep(-Inf,16)
    } else if (!spec$restric =="ph-var"){ # lower bound for all models that are not ph-var and not h-var! (i.e., invarB-res-Models)
      lb <- c(rep(bound, K*(K-1)), rep(zero_bound,K-1), bound)
    }
    # lower bound for unrestricted B-Matrix (NO zeros in last column)
  } else if (spec$restric =="invarB") {
    lb <- rep(bound, K*K)
  }

    ob_fun <- function(unknown) LogLike_ms_condml(unknown, Lambda_pos,KsiT,Tm,spec,u_est,Samp,K,spec$lag)
  # gradient <- function(unknown) nl.grad(unknown, ob_fun)
  # res <-   solnp(pars=c(BL), fun=ob_fun, LB=lb, eqfun=switch((!spec$res==FALSE), eq_res_B,NULL) , eqB=switch(!spec$res==FALSE, c(rep(0,K-1), rep(0, (K-1)-spec$lenb)), NULL), control=list(trace=FALSE))
  
  if (spec$restric == "invarB"){
    res <-  solnp(pars=c(B), fun=ob_fun, LB=lb, control=list(trace=FALSE))
  }
  if (spec$restric == "invarB-res"){
    res <-  solnp(pars=c(B), fun=ob_fun, LB=lb, eqfun= eq_res_B , eqB=rep(0,K-1), control=list(trace=FALSE))
  }
  if (spec$restric == "ph-var"){
    res <-   solnp(pars=c(B), fun=ob_fun,  eqfun= eq_res_B , eqB=c(rep(0,K-1), rep(0, (K-1)-spec$lenb)), control=list(trace=FALSE))
  }
  
} else { # for h-var model (i.e., spec$lenb == 0)
  eq_res_B <- function(unknown) eq_restr_B_condml(unknown, Lambda_pos,spec, Samp, K)
  B[K,1:(K-1)]  <-  0
  lb_help <-  matrix(bound, K,K)
  lb_help[K,1:(K-1)]  <-  zero_bound
  eqB_out <-  rep(0, K-1)
  if (spec$restric == "h-var-res"){
    B[1:(K-1),K]  <-  0
    lb_help[1:(K-1),K]  <-  zero_bound
    eqB_out <-  c(eqB_out,rep(0, K-1))
    
  }
  lb <- c(lb_help)

  ob_fun <- function(unknown) LogLike_ms_condml(unknown, Lambda_pos,KsiT,Tm,spec,u_est,Samp,K,spec$lag)
  res <-   solnp(pars=c(B), LB=lb,fun=ob_fun, eqfun=eq_res_B , eqB=eqB_out, control=list(trace=FALSE))
  
}
par <- c(res$pars)
val <- res$values[length(res$values)]

out <- list(B = par,val = val)
} # end of function minimize_ms

