minimize_ms_ins <- function(KsiT,Samp,K,Tm, Lambda, B, spec, u_est ,Theta, RND_ALL , beta=c(), lambda_nu=c()){
  
  # Matrix of parameters to maximize <- first B, then in the next columns diag elements of Lambda
  BL <- B
  for (position in 1:(spec$states-1)){
    Lambda_pos <- diag(as.matrix(Lambda[(position*K+1): (K*(position+1)),]))
    BL <- cbind(BL, Lambda_pos)
  }
  if (RND_ALL==1){
    beta <- c(0,0,0)[1:spec$lenb]
    lambda_nu <- c(1.1,10.1)
  }
  ini <- c(BL, beta, lambda_nu) 
  
  if (spec$res == "het"){
    lb <- c(rep(-Inf,K^2), rep(0.001, K*(spec$states-1) ), rep(-10^5, spec$lenb), rep(0.01, spec$states) )
    
    eq_restr_ins <- function(unknown) eq_rest_beta_ms(unknown,y,Z, spec, Samp, K,id_res=c(1:spec$lenb))
    heq_jac <- function(unknown) nl.jacobian(unknown, eq_restr_ins)
    ob_fun <- function(unknown) LogLike_ms_ins(unknown,KsiT, Tm, spec, u_est, Samp, K, lag_length,lenb=spec$lenb)
    res <-   solnp(pars=ini, fun=ob_fun, eqfun = eq_restr_ins, eqB=c(0,0,0)[1:spec$lenb], LB=lb)
    
  } else if (spec$res != "het"){
    lb <- c(rep(-Inf,K^2), rep(0.001, K*(spec$states-1) ), rep(-1000, spec$lenb), rep(0.01, spec$states) )
    ob_fun <- function(unknown) LogLike_ms_ins(unknown,KsiT, Tm, spec, u_est, Samp, K, lag_length,lenb=spec$lenb)
  }
  
  val <- res$values[length(res$values)]
  B <- c()
  for (i in 1:K^2){
    B[i] <- res$par[i]
  }
  B <- matrix(B, K,K)
  Lambda_vec <- c()
  count <- 0
  for (i in (K^2+1):(K^2+(spec$states-1)*K)){
    count <- count +1
    Lambda_vec[count] <- res$par[i]
  }
  
  BL <- cbind(B, matrix(Lambda_vec, K, spec$states-1))
  beta <-c(res$par)[((K^2)+(spec$states-1)*K+1):((K^2)+(spec$states-1)*K+spec$lenb)]
  lambda_nu <-c(res$par)[((K^2)+(spec$states-1)*K+spec$lenb+1):((K^2)+(spec$states-1)*K+spec$lenb+spec$states)]
  
  out <- list(BL = BL, val = val, beta=beta, lambda_nu=lambda_nu)
} # end of function minimize_ms

