minimize_ms_unres <- function(KsiT,Samp,K,Tm, Sigma, spec, u_est ,Theta, ROUND){
  
  # Matrix of parameters to maximize <- first B, then in the next columns diag elements of Lambda
  x <- c()
  for (i in 1:spec$states){
    help <- vech(Sigma[((1+K*(i-1)):(K*i)), ])
    x <- c(x,help)
  }
  
  # THE CAREFUL SPECIFICATION OF UPPER AND LOWER BOUNDS IS CRUCIAL!
  lb <- lbound(K,spec, unres = TRUE)
  ub  <- ubound(K,spec, unres = TRUE)
  
  ob_fun <- function(unknown) LogLike_unres2(unknown,KsiT,Tm,spec,u_est,Samp,K)
  gradient <-  function(unknown) nl.grad(unknown, ob_fun)
  
  eigen_contr <- c() # if eigenvalues of Sigma smaller than threshold, break the loop and return with no result
  for (position in 1:spec$states){
    eigen_contr <-  c(eigen_contr, eigen(Sigma[(1+K*(position-1)):(K*position),])$values)
  }
 
  uneq_res_sig <- function(unknown) uneq_restr_sigma(unknown,spec, Samp, K)
  hin_jac <-  function(unknown) nl.jacobian(unknown, uneq_res_sig)
  
  res <-  solnp(pars=c(x), fun=ob_fun, ineqfun= uneq_res_sig, UB = ub,LB = lb, ineqLB=rep(0, length(eigen_contr)), ineqUB =rep(Inf, length(eigen_contr)))
  par <- res$pars
  val <- res$values[length(res$values)]
  out <- list(Sigma = par, val = val)
} # end of function minimize_ms
