param_stderr <- function(Samp, K,estimation, spec, y, Z, log_path,way = 1, amod=FALSE){
  
  # to account for trend or no trend
  add <- 1
  if (dim(estimation$Theta)[2]/(K*spec$lag+1)!=1){
    add <- 2
  }
  ##########################################################################################
  # Three ways to calculate the parameters' covariance matrix (plus gradient and hessian)  #
  ##########################################################################################
  if (amod==TRUE){
    if (spec$states == 2){
      # param <- cbind(t(c(estimation$B)),  t(c(4.13745181778764,
      # 16.3602684017454, 6.18301670146521)),  t(c(estimation$Theta)) , t(c(0.909242087313476, 1-0.608876205167668)))
      param <- cbind(t(c(estimation$A[-(seq(1, K^2, K+1))])),  t(diag(as.matrix(estimation$Lambda[1:K,]))), t(diag(as.matrix(estimation$Lambda[(K+1):(K*2),]))),  t(c(estimation$Theta)) , t(c(estimation$P[1:(spec$states-1),])))
      
    } else if (spec$states ==3){
      param <- cbind(t(c(estimation$A[-(seq(1, K^2, K+1))])),  t(diag(as.matrix(estimation$Lambda[1:K,]))), t(diag(as.matrix(estimation$Lambda[(K+1):(K*2),]))), t(diag(as.matrix(estimation$Lambda[(K*2+1):(K*3),]))), t(c(estimation$Theta)) , t(c(estimation$P[1:(spec$states-1),])))
      
    } else if (spec$states ==4){
      param <- cbind(t(c(estimation$A[-(seq(1, K^2, K+1))])),  t(diag(as.matrix(estimation$Lambda[1:K,]))), t(diag(as.matrix(estimation$Lambda[(K+1):(K*2),]))), t(diag(as.matrix(estimation$Lambda[(K*2+1):(K*3),]))),t(diag(as.matrix(estimation$Lambda[(K*3+1):(K*4),]))), t(c(estimation$Theta)) , t(c(estimation$P[1:(spec$states-1),])))
    }    
  } else if (amod==FALSE){
    if (spec$states == 2){
      param <- cbind(t(c(estimation$B)),  t(diag(as.matrix(estimation$Lambda[(K+1):(K*2),]))),  t(c(estimation$Theta)) , t(c(estimation$P[1:(spec$states-1),])))
    } else if (spec$states ==3){
      param <- cbind(t(c(estimation$B)),  t(diag(as.matrix(estimation$Lambda[(K+1):(K*2),]))), t(diag(as.matrix(estimation$Lambda[(K*2+1):(K*3),]))), t(c(estimation$Theta)) , t(c(estimation$P[1:(spec$states-1),])))
    } else if (spec$states ==4){
      param <- cbind(t(c(estimation$B)),  t(diag(as.matrix(estimation$Lambda[(K+1):(K*2),]))),  t(diag(as.matrix(estimation$Lambda[(K*2+1):(K*3),]))),t(diag(as.matrix(estimation$Lambda[(K*3+1):(K*4),]))),   t(c(estimation$Theta)) , t(c(estimation$P[1:(spec$states-1),])))
    }    
  }
  
  # get the parameters in the rigth shape
  param <- t(param) 
  if (way == 1){
    delta <- 1e-4 *abs(param) + 0.00000001
    s <- matrix(NA, Samp-spec$lag, length(param))
    hh <- rep(0, length(param))
    # gradient for all observations (vector_out =TRUE)
    for (n in 1:length(param)){
      hh[n] <- delta[n]
      if (amod ==TRUE){
        s[,n] <- (Likelihood_all_dep_a(param+ hh,  K,Samp, spec, estimation, y, Z, vector_out =TRUE) - Likelihood_all_dep_a(param,  K,Samp, spec, estimation,y, Z,vector_out =TRUE))/delta[n]      
      } else if(amod ==FALSE){
        s[,n] <- (Likelihood_all_dep(param+ hh,  K,Samp, spec, estimation, y, Z, vector_out =TRUE) - Likelihood_all_dep(param,  K,Samp, spec, estimation,y, Z,vector_out =TRUE))/delta[n]      
      }
      
      hh[n] <- 0
    }
    
    # this functions calculates the LL dependent on all model parameters (param). In case single = true it returns a numeric
    #######################################
    # form outer product matrix as in Hamilton eq 5.8.4
    sum_s_matrix <- matrix(0,numel(param),numel(param))
    s_matrix <- matrix(NA, numel(param),numel(param))
    for (idx in 1:(Samp-spec$lag)){
      s_matrix <- s[idx,]%*%t(s[idx,])
      sum_s_matrix <- sum_s_matrix + s_matrix
    } # end of idx loop
    
    op_matrix <- sum_s_matrix/Samp
    hess <-  sum_s_matrix
    Sterrors <- matrix(sqrt(diag(solve(op_matrix*Samp, tol=10^-40) )), numel(param),1)
    
  } else if (way == 2){
    
    # gradient:  central
    delta <- 10^-6#.Machine$double.eps^(1/3)
    grad=c()
    hh <- rep(0, length(param))
    for (n in 1:length(param)){
      hh[n] <- delta
      grad[n] <-  (Likelihood_all_dep(param+ hh,  K,Samp, spec, estimation, y,Z, vector_out = FALSE)- Likelihood_all_dep(param- hh, K,Samp, spec, estimation,y,Z, vector_out = FALSE))/(2*delta)
      hh[n] <- 0
    }
    
    # Hessian
    hess <- matrix (NA, length(param), length(param))
    hh <- rep(0, length(param))
    for (n in 1:length(param)){
      for (m in 1:n){
        xpp <- param
        xpp[n] <- xpp[n] + delta
        xpp[m] <-  xpp[m] + delta
        ypp <-  Likelihood_all_dep(xpp, K,Samp, spec, estimation,y,Z, vector_out = FALSE)
        
        xpm <- param
        xpm[n] <- xpm[n] + delta
        xpm[m] <-  xpm[m] - delta
        ypm <-  Likelihood_all_dep(xpm, K,Samp, spec, estimation, y,Z,vector_out = FALSE)
        
        xmp <- param
        xmp[n] <- xmp[n] - delta
        xmp[m] <-  xmp[m] + delta
        ymp <-  Likelihood_all_dep(xmp, K,Samp, spec, estimation,y,Z, vector_out = FALSE)
        
        xmm <- param
        xmm[n] <- xmm[n] - delta
        xmm[m] <-  xmm[m] - delta
        ymm <-  Likelihood_all_dep(xmm, K,Samp, spec, estimation,y,Z, vector_out = FALSE)
        
        hess[n,m] <- (ypp - ypm - ymp + ymm)/(4*delta*delta)
        hess[m,n]<- hess[n,m]
        
      }
      cat("Calculation of Hessian. Param: "  , n, " of ",length(param),".\n\r", sep="")
      # cat(paste("Calculation of Hessian. Param: "  , n, " of ",length(param),".\n\r", sep=""), file=log_path, append=TRUE)
    }
    
    cov_model <- solve(hess)
    Sterrors <- sqrt(diag(cov_model))
    
  } else if (way == 3){
    
    delta <- 10^-5.5
    grad <- c()
    hh <- rep(0, length(param))
    # gradient for all observations (vector_out =TRUE)
    for (n in 1:length(param)){
      
      hh[n] <- delta
      if (amod ==TRUE){
        grad[n] <-  (Likelihood_all_dep_a(param + hh,  K,Samp, spec, estimation,y,Z, vector_out = FALSE) - Likelihood_all_dep_a(param, K,Samp, spec, estimation,y, Z,vector_out = FALSE))/(2*delta)    
        
      } else if(amod ==FALSE){
        grad[n] <-  (Likelihood_all_dep(param + hh,  K,Samp, spec, estimation,y,Z, vector_out = FALSE) - Likelihood_all_dep(param, K,Samp, spec, estimation,y, Z,vector_out = FALSE))/(2*delta)    
      }
      hh[n] <- 0
    }
    
    # Hessian
    hess <- matrix (NA, length(param), length(param))
    hh <- rep(0, length(param))
    for (n in 1:length(param)){
      for (m in 1:n){
        hh[n] <- delta
        
        if (amod ==TRUE){
          yn <-  Likelihood_all_de_a(param + hh,  K,Samp, spec, estimation,y,Z,vector_out = FALSE)
        } else if(amod ==FALSE){
          yn <-  Likelihood_all_dep(param + hh,  K,Samp, spec, estimation,y,Z,vector_out = FALSE)
        }
        
        hh[n] <- 0
        
        hh[m] <- delta
        if (amod ==TRUE){
          ym <-  Likelihood_all_dep_a(param + hh,  K,Samp, spec, estimation,y,Z, vector_out = FALSE)
        } else if(amod ==FALSE){
          ym <-  Likelihood_all_dep(param + hh,  K,Samp, spec, estimation,y,Z, vector_out = FALSE)
        }
        
        
        hh[m] <- 0
        
        xnm <- param
        xnm[n] <- xnm[n] + delta
        xnm[m] <-  xnm[m] + delta
        if (amod ==TRUE){
          ynm <-  Likelihood_all_dep_a(xnm, K,Samp, spec, estimation,y,Z, vector_out = FALSE)
          y_pl <-  Likelihood_all_dep_a(param, K,Samp, spec, estimation,y,Z, vector_out = FALSE)
        } else if(amod ==FALSE){
          ynm <-  Likelihood_all_dep(xnm, K,Samp, spec, estimation,y,Z, vector_out = FALSE)
          y_pl <-  Likelihood_all_dep(param, K,Samp, spec, estimation,y,Z, vector_out = FALSE)
        }
        
        hess[n,m] <- (ynm - yn - ym + y_pl)/(delta*delta)
        hess[m,n]<- hess[n,m]
        
      }
      cat("Calculation of Hessian. Param: "  , n, " of ",length(param),".\n\r", sep="")
      # cat(paste("Calculation of Hessian. Param: "  , n, " of ",length(param),".\n\r", sep=""), file=log_path, append=TRUE)
      
    }
    
    cov_model <- solve(hess)
    Sterrors <- sqrt(diag(cov_model))
  }
  if (amod ==TRUE){ 
    A_Sterrors <- matrix(NA, K,K)
    idx <- which(c(as.logical(upper.tri(A_Sterrors, diag=FALSE) +  lower.tri(A_Sterrors, diag=FALSE))))
    counter <- 0
    for (i in idx){
      counter <- counter +1
      A_Sterrors[i] <-  Sterrors[counter]
    } 
    Lambda_Sterrors_vec <- Sterrors[(K^2-K+1):(K^2-K+spec$states*K)]
    if (spec$states ==2){
      Lambda_Sterrors <- rbind(diag(Lambda_Sterrors_vec[1:K]),diag(Lambda_Sterrors_vec[(K+1):(2*K)]))
    } else if (spec$states ==3){
      Lambda_Sterrors <- rbind(diag(Lambda_Sterrors_vec[1:K]), diag(Lambda_Sterrors_vec[(K+1):(2*K)]),diag(Lambda_Sterrors_vec[(2*K+1):(3*K)]))
    } else if (spec$states ==4){
      Lambda_Sterrors <- rbind(diag(Lambda_Sterrors_vec[1:K]), diag(Lambda_Sterrors_vec[(K+1):(2*K)]), diag(Lambda_Sterrors_vec[(2*K+1):(3*K)]),diag(Lambda_Sterrors_vec[(3*K+1):(4*K)]))
    }
    VAR_Sterrors <- matrix(Sterrors[(K^2-K+spec$states*K+1):(K^2-K+spec$states*K+spec$lag*K^2+add*K)],K,dim(Z)[2])
    P_Sterrors <- rbind(matrix(Sterrors[(K^2-K+spec$states*K+spec$lag*K^2+add*K+1):length(Sterrors)], spec$states-1, spec$states), rep(NA, spec$states))
    
  } else if(amod ==FALSE){
    
    B_Sterrors <- matrix(Sterrors[1:K^2], K,K)
    if (spec$states ==2){
      Lambda_Sterrors <- diag(Sterrors[(K^2+1):(K^2+(spec$states-1)*K)])
    } else if (spec$states ==3){
      Lambda_Sterrors_vec <- Sterrors[(K^2+1):(K^2+(spec$states-1)*K)]
      Lambda_Sterrors <- rbind(diag(Lambda_Sterrors_vec[1:K]), diag(Lambda_Sterrors_vec[(K+1):(2*K)]))
    } else if (spec$states ==4){
      Lambda_Sterrors_vec <- Sterrors[(K^2+1):(K^2+(spec$states-1)*K)]
      Lambda_Sterrors <- rbind(diag(Lambda_Sterrors_vec[1:K]), diag(Lambda_Sterrors_vec[(K+1):(2*K)]), diag(Lambda_Sterrors_vec[(2*K+1):(3*K)]))
    }
    VAR_Sterrors <- matrix(Sterrors[(K^2+(spec$states-1)*K+1):(K^2+(spec$states-1)*K+spec$lag*K^2+add*K)],K,dim(Z)[2])
    P_Sterrors <- rbind(matrix(Sterrors[(K^2+(spec$states-1)*K+spec$lag*K^2+add*K+1):length(Sterrors)], spec$states-1, spec$states), rep(NA, spec$states))
  }
  
  out <- list(param = c(param), Sterrors =  Sterrors , B_se = switch(!amod==TRUE, B_Sterrors,NULL ), A_se = switch(amod==TRUE, A_Sterrors,NULL), Lambda_se = Lambda_Sterrors, Var_se = VAR_Sterrors,P_se =P_Sterrors, hessian = hess)
  return(out)
}