param_stderr_ins <- function(Samp, K,estimation, spec, y, Z, log_path,way = 1){
  
  ##########################################################################################
  # Three ways to calculate the parameters' covariance matrix (plus gradient and hessian)  #
  ##########################################################################################
  if (spec$states == 2){
    param <- cbind(t(c(estimation$B)),  t(diag(as.matrix(estimation$Lambda[(K+1):(K*2),]))),  t(c(estimation$Theta)), t(c(estimation$beta)), t(c(estimation$lambda_nu)), t(c(estimation$P[1:(spec$states-1),])) )
  } else if (spec$states ==3){
    param <- cbind(t(c(estimation$B)),  t(diag(as.matrix(estimation$Lambda[(K+1):(K*2),]))), t(diag(as.matrix(estimation$Lambda[(K*2+1):(K*3),]))), t(c(estimation$Theta)) , t(c(estimation$beta)), t(c(estimation$lambda_nu)), t(c(estimation$P[1:(spec$states-1),])) )
  } else if (spec$states ==4){
    param <- cbind(t(c(estimation$B)),  t(diag(as.matrix(estimation$Lambda[(K+1):(K*2),]))),  t(diag(as.matrix(estimation$Lambda[(K*2+1):(K*3),]))),t(diag(as.matrix(estimation$Lambda[(K*3+1):(K*4),]))),   t(c(estimation$Theta)) , t(c(estimation$beta)), t(c(estimation$lambda_nu)), t(c(estimation$P[1:(spec$states-1),])) )
  }
  
  # get the parameters in the rigth shape
  param <- t(param)
  
  delta <- 1e-4 *abs(param) + 0.00000001
  s <- matrix(NA, Samp-spec$lag, length(param))
  hh <- rep(0, length(param))
  # gradient for all observations (vector_out =TRUE)
  for (n in 1:length(param)){
    hh[n] <- delta[n]
    if (var_aug ==TRUE){
      s[,n] <- (Likelihood_all_dep_ins(param+ hh,  K,Samp, spec, estimation, y, Z, vector_out =TRUE) - Likelihood_all_dep_ins(param,  K,Samp, spec, estimation,y, Z,vector_out =TRUE))/delta[n]
    } else if (var_aug ==FALSE){
      s[,n] <- (Likelihood_all_dep(param+ hh,  dim(y)[2],Samp, spec, estimation, y, Z, vector_out =TRUE) - Likelihood_all_dep(param,  dim(y)[2],Samp, spec, estimation,y, Z,vector_out =TRUE))/delta[n]
    }
    hh[n] <- 0
  }
  
  # this functions calculates the LL dependent on all model parameters (param). In case single = true it returns a numeric
  #######################################
  # form outer product matrix as in Hamilton eq 5.8.4
  sum_s_matrix <- matrix(0,numel(param),numel(param))
  s_matrix <- matrix(NA, numel(param),numel(param))
  for (idx in 1:(Samp-spec$lag)){
    s_matrix <- s[idx,]%*%t(s[idx,])
    sum_s_matrix <- sum_s_matrix + s_matrix
  } # end of idx loop
  
  op_matrix <- sum_s_matrix/Samp
  hess <-  sum_s_matrix
  Sterrors <- matrix(sqrt(diag(solve(op_matrix*Samp, tol=10^-40) )), numel(param),1)
  
  B_Sterrors <- matrix(Sterrors[1:K^2], K,K)
  if (spec$states ==2){
    Lambda_Sterrors <- diag(Sterrors[(K^2+1):(K^2+(spec$states-1)*K)])
  } else if (spec$states ==3){
    Lambda_Sterrors_vec <- Sterrors[(K^2+1):(K^2+(spec$states-1)*K)]
    Lambda_Sterrors <- rbind(diag(Lambda_Sterrors_vec[1:K]), diag(Lambda_Sterrors_vec[(K+1):(2*K)]))
  } else if (spec$states ==4){
    Lambda_Sterrors_vec <- Sterrors[(K^2+1):(K^2+(spec$states-1)*K)]
    Lambda_Sterrors <- rbind(diag(Lambda_Sterrors_vec[1:K]), diag(Lambda_Sterrors_vec[(K+1):(2*K)]), diag(Lambda_Sterrors_vec[(2*K+1):(3*K)]))
  }
  VAR_Sterrors <- matrix(Sterrors[(K^2+(spec$states-1)*K+1):(K^2+(spec$states-1)*K+spec$lag*dim(y)[2]^2+dim(y)[2])],dim(y)[2],spec$lag*dim(y)[2]+1)
  beta_Sterrors <- matrix(Sterrors[(K^2+(spec$states-1)*K+spec$lag*dim(y)[2]^2+dim(y)[2]+1):(K^2+(spec$states-1)*K+spec$lag*dim(y)[2]^2+dim(y)[2]+length(estimation$beta))],length(estimation$beta),1)
  lambda_nu_Sterrors <- matrix(Sterrors[(K^2+(spec$states-1)*K+spec$lag*dim(y)[2]^2+dim(y)[2]+length(estimation$beta)+1):(K^2+(spec$states-1)*K+spec$lag*dim(y)[2]^2+dim(y)[2]+length(estimation$beta)+spec$states)],spec$states,1) 
  P_Sterrors <- rbind(matrix(Sterrors[(K^2+(spec$states-1)*K+spec$lag*dim(y)[2]^2+dim(y)[2]+length(estimation$beta)+spec$states+1):length(Sterrors)], spec$states-1, spec$states), rep(NA, spec$states))
  
  out <- list(param = c(param), lambda_nu_Sterrors=lambda_nu_Sterrors, beta_Sterrors=beta_Sterrors, Sterrors =  Sterrors , B_se = B_Sterrors, Lambda_se = Lambda_Sterrors, Var_se = VAR_Sterrors,P_se =P_Sterrors, hessian = hess)
  return(out)
}