calc_variance_decomp_proxy <- function(Phi, struc_error, K,  spec,  horizon){
  var_decomp <- array(NA, dim=c(horizon,K,K))
  MSE_y <- array(data=NA, dim=c(dim(Phi[,,1])[1], dim(Phi[,,1])[1], horizon ))
  MSE_yjt <- array(data=NA, dim=c(dim(Phi[,,1])[1], horizon ))
  
  for (h in 1:horizon){
    MSE_y[,,h] <-  Phi[,,h]%*%t(Phi[,,h])
    if (h == 1){
      MSE_yjt[,h] <-  diag(MSE_y[,,h])  
    } else if (h != 1){
      MSE_yjt[,h] <- MSE_yjt[,(h-1)] + diag(MSE_y[,,h])    
    }
  }
  
  ident <-  diag(rep(K))
  omega_jk = c()
  
  for (j in 1:K){
    e_j <- ident[,j]
    for (k in 1:K){
      e_k <- ident[,k]
      omega_jk <- c()
      omega_jk_help <- c()
      for (h in 1:horizon){
        if (h == 1){
          omega_jk_help[1] <- (t(e_j)%*%Phi[,,h]%*%e_k)^2
        } else if (h != 1) {
          omega_jk_help[h] <-  omega_jk_help[h-1] + (t(e_j)%*%Phi[,,h]%*%e_k)^2
        }
        omega_jk[h] <- omega_jk_help[h]/MSE_yjt[j,h]   
      }
      var_decomp[,k,j] <- omega_jk
    }
  }
  
  
  return(var_decomp)  
} # function end
