create_boot_data_proxy <-  function(y, y_start, lag_length, spec, Samp, Theta, K, u_est, date_list, instrument = NULL){
  y_comp <- as.matrix(rbind(y_start, y))
  y_star <- matrix(NA, Samp,K)
  y_star[(1:lag_length),] <- matrix(y_start,lag_length, K)
  
  # Rademacher distribution
  rade <-   sample(c(-1, 1), size=(Samp-lag_length),replace=TRUE, prob=c(0.5, 0.5))
  u_star <- u_est*rade
  
  if (!is.null(instrument)){
    row_start <- which(grepl(date_list[[2]][1], date_list[[1]]))
    row_end <- which(grepl(date_list[[2]][length(date_list[[2]])], date_list[[1]]))-spec$lag
    instrument_star <-  instrument*rade[row_start:row_end]
  }
  
  # Starting values
  for (l in (lag_length+1):Samp){ 
    for (i in 1:lag_length){
      if (i == 1){
        y_star[l,] <- Theta[,1] + u_star[(l-lag_length),]
      }
      # y_star[l,] <-  y_star[l,]  + t(Theta[, ((i-1)*K+2):((i-1)*K+K+1)]%*% y_comp[l-i,])
      y_star[l,] <-  y_star[l,]  + t(Theta[, ((i-1)*K+2):((i-1)*K+K+1)]%*% y_star[l-i,])
      
    }  # end of loop throug i
  } # end of loop through l
  
  #generate Z matrix with constant
  con <- matrix(1,Samp-lag_length,1)
  y_star_lag <- y_lag_cr(y_star, lag_length)$lags
  Z_star <- cbind(con, y_star_lag)
  y_star <- (y_star[-(1:lag_length),])
  return(list(y_star = y_star, Z_star = Z_star, u_star = u_star, instrument_star =if (!exists("instrument_star")){c()} else{instrument_star}))
}

