impulse_vecs <- function(u_est, spec, Samp_adj, K){
  
  inst_reg <- instrument_reg_mult(u_est=u_est, instrument=spec$instrument, spec$pos_instr, spec, Samp_adj=Samp_adj, K)
  
  mu <-  inst_reg$gamma
  Sigma <- ((Samp_adj-spec$lag)-(1+spec$lag*K))^-1*t(u_est)%*%u_est  
  
  # See Notes of Michele Piffer page 15/16
  sigma_21 <- Sigma[-spec$pos_instr,spec$pos_instr]
  sigma_11 <- Sigma[spec$pos_instr,spec$pos_instr]
  Sigma_22 <- Sigma[-spec$pos_instr,-spec$pos_instr]
  
  b12_b12 <- t(sigma_21-sigma_11*mu)%*%solve(-(Sigma_22-sigma_11*mu%*%t(mu))+(Sigma_22-sigma_21%*%t(mu))+t(Sigma_22-sigma_21%*%t(mu)))%*%(sigma_21-sigma_11*mu)
  b11 <-  c(sqrt(Sigma[spec$pos_instr, spec$pos_instr] - b12_b12) ) 
  
  b21 <- b11*mu  
  b1 <-  c(if ((spec$pos_instr-1)>=1){b21[1:(spec$pos_instr-1)]}else{NULL}, b11, if (spec$pos_instr<=length(b21)){b21[spec$pos_instr:length(b21)]}else{NULL})
  
  out <- list(abs_impulse =b1, rel_impulse = mu, f_test = inst_reg$f_test, f_robust = inst_reg$f_robust)
  return(out)
}
