instrument_reg_mult <-  function(u_est, instrument, pos_instr, spec, Samp_adj, K ){
  
  spec$constant <- FALSE
  
  instrument <-  as.matrix(instrument)
  length_dif <- dim(instrument)[1]-dim(u_est)[1]
  if (length_dif > 0){
    instrument <- as.matrix(instrument[-c(1:length_dif),])
  }
  
  dim_ins <- dim(spec$ins)
  
  y_step1 <- as.matrix(c(t(u_est[,pos_instr])) )
  if (!is.null(spec$constant) && spec$constant == FALSE){
    Z_step1 <-  as.matrix(instrument)
    Z_step_res <-  as.matrix(rep(1,dim(u_est)[1]))
    
  } else {
    Z_step1 <-  cbind(rep(1,dim(u_est)[1]), instrument)
    Z_step_res <-  as.matrix(rep(1,dim(u_est)[1]))
    
  }
  coef_res <- solve(t(Z_step_res)%*%Z_step_res)%*%t(Z_step_res)%*%y_step1
  
  resid_res <-  residuals2(y_step1,coef_res,Z_step_res)
  RSS_rest <- t(resid_res)%*%resid_res
  # regress u on instrument
  est_step <- solve(t(Z_step1)%*%Z_step1)%*%t(Z_step1)%*%y_step1
  
  resid_first <- residuals2(y_step1,est_step,Z_step1)
  RSS <- t(resid_first)%*%resid_first
  # calc fitted values
  fit_val <-  t(kronecker(diag(dim(y_step1)[1]),est_step))%*%c(t(Z_step1))
  
  f_test <- c(t(fit_val-mean(y_step1))%*%(fit_val-mean(y_step1))/(1) / (t(resid_first)%*%resid_first/(Samp_adj-spec$lag-2)))
  # regress the remaining VAR residuals on fitted values of instrumented residual  
  y_step2 <- as.matrix(c(t(u_est[,-(pos_instr)])) )
  if (!is.null(spec$constant) && spec$constant == FALSE){
    Z_step2 <- as.matrix(fit_val)
    R <-  diag(K-1)
    A1 <- t(R)%*%kronecker(t(Z_step2)%*%Z_step2,diag(K-1))%*%R
    A2 <- t(R)%*%kronecker(t(Z_step2), diag(K-1))%*%y_step2
    gamma <-  solve(A1)%*%A2  
    #### Heteroskedasticity ROBUST F-Test
    R <- matrix(rep(1,dim(instrument)[2]), nrow=1)
    r <- rep(0, 1)
    S_hat <- t(Z_step1)%*%diag(c(resid_first)^2)%*%Z_step1
    Avarb <- solve(t(Z_step1)%*%Z_step1)%*%S_hat%*%solve(t(Z_step1)%*%Z_step1)
    f_robust <- t(R%*%est_step-r)%*%solve(R%*%Avarb%*%t(R))%*%(R%*%est_step-r)
  } else {
    Z_step2 <-  cbind(rep(1,dim(u_est)[1]), fit_val)
    R <-  diag((K-1)*dim_ins+(K-1))
    A1 <- t(R)%*%kronecker(t(Z_step2)%*%Z_step2,diag(K-1))%*%R
    A2 <- t(R)%*%kronecker(t(Z_step2), diag(K-1))%*%y_step2
    gamma <-  solve(A1)%*%A2  
    # crop the constant
    gamma <-  gamma[-c(1:(K-1))]
    #### Heteroskedasticity ROBUST F-Test
    R <- matrix(c(0,rep(1,dim(instrument)[2])), nrow=1)
    r <- rep(0, 1)
    S_hat <- t(Z_step1)%*%diag(c(resid_first)^2)%*%Z_step1
    Avarb <- solve(t(Z_step1)%*%Z_step1)%*%S_hat%*%solve(t(Z_step1)%*%Z_step1)
    f_robust <- t(R%*%est_step-r)%*%solve(R%*%Avarb%*%t(R))%*%(R%*%est_step-r)
  }
  out <- list(gamma = gamma, f_test = f_test,f_robust=f_robust)
  return(out)
}
