data_exogenous2 <- function(Samp,K, coef_true, mean, B_true, Lambda_true, beta_true, lambda_nu, spec){
  
  # generate the structural shocks that depend on Sigma_st
  Sigma_st  <- vector(mode="list", length=Samp)
  noise_variance <- vector(mode="list", length=Samp)
  eps <- matrix(NA, Samp, K)
  noise <- vector(mode="list", length=Samp)
  for (i in 1:Samp){
    if (i <= Samp*spec$bp){
      eps[i,] <-   rmvnorm(1, c(mean), Lambda_true[[1]])
      noise[[i]] <- rmvnorm(1, rep(0, spec$ins_dim), lambda_nu[[1]])
    }
    if (i > Samp*spec$bp){
      eps[i,] <-   rmvnorm(1, c(mean), Lambda_true[[2]])
      noise[[i]] <- rmvnorm(1, rep(0, spec$ins_dim), lambda_nu[[2]])
    }
  }
  # generate the instrument
  instrument <- matrix(NA, Samp, spec$ins_dim)
  for (i in 1:Samp){
    instrument[i,] <- t(beta_true %*% eps[i,]) + noise[[i]]
  }
  
  # generate the residuals that depend on Sigma_st
  u <- matrix(NA, Samp, K)
  for (i in 1:Samp){
    u[i,] <-   t(B_true%*%eps[i,])
  }
  
  #               ####################### 
  #               # Generate the data   #
  #               #######################
  spec$deter <- as.matrix(rep(1,Samp))
  # generate data recursively
  Theta <-  matrix(unlist(coef_true), nrow=K) # build coefficient matrix
  mean_ts <- (solve(diag(K*spec$lag) - var_companion(Theta, K, spec)$A_var)%*% c(coef_true$intercept,rep(0, K*(spec$lag-1))))[1:K,]
  y <-  rbind(matrix(rep(mean_ts, each=spec$lag), ncol=K),matrix(0,dim(u)[1] ,dim(u)[2]))
  for  (r in (spec$lag+1):(Samp+spec$lag)){
    y[r,] <- Theta%*%c(1,c(t(y[(r-1):(r-spec$lag),]))) + u[r-spec$lag,]
  }
  # cut starting values
  y <- y[-c(1:spec$lag),]
  
  out <- list(y=y,resid=u, states_dgp = spec$bp, struc_shocks=eps, instrument=instrument)
}# end of function
