make_coef <- function(K, lag_length, kind, conf_shift=FALSE){
  if (kind ==1){
    
    if (lag_length ==1){
      intercept <- c(0,0,0)[1:K]
      A1 <-  matrix(c(.79,0.19,0.12,0,0.95,0,0.25,-0.46,0.62), 3,3)[1:K,1:K]
      coef <-  list(intercept=intercept, A1 = A1)
    }
    if (lag_length ==2){
      intercept <- c(0,0,0)[1:K]
      A1 <-  matrix(c(.79,0.19,0.12,0,0.95,0,0.25,-0.46,0.62), K,K)[1:K,1:K] # True value for the autoregressive coefficient
      A2 <-  matrix(c(0.95,0,0.25,-0.46), K,K) # True value for the autoregressive coefficient
      coef <-  list(intercept=intercept, A1 = A1, A2=A2)
    }
  } else if (kind ==2){
    if (K == 1){   
      mean <- c(0) # mean of the residuals
    } else if (K == 2) {
      mean <- c(0,0) # mean of the residuals
    } else if (K== 3)  
      mean <-  c(0,0,0)
  } else if (kind ==3){
    if (K == 2){
      B_true <- matrix(c(0.69,-1.1, 0,1), K,K)
    } else if (K==3){
      B_true <- matrix(c(0.69,-1.1,-0.75, 0,1,0, 0.61,1.49,1.49), K,K)
    }
    
    if (conf_shift == TRUE){
      Lambda_true <- list(diag(K), 2*diag(K)+diag(c(0.5,3,7), K,K), 2*diag(K) +diag(c(1,5,10)))
    } else if  (lambda_alt == TRUE){
      Lambda_true <- list(diag(K), diag(c(0.5, 1,2), K,K),  diag(c(1,1,1)))
    }   else  {
      # Lambda_true <- list(diag(K), diag(c(7, 3, 0.5), K,K),  diag(c(20,10,4)))
      Lambda_true <- list(diag(K), diag(c(0.5 , 3,7), K,K),  diag(c(4,10,20)))
    }
    # create variance object
    # sigma <-  list(first= matrix(c(1,0,0,0,2,0,0,0,5), 3,3), second = matrix(c(.2,0,0,0,1,0,0,0,10), 3,3))
    out <- list(B_true = B_true, Lambda_true =Lambda_true) 
  } 
  
  if (kind==1){
    return(coef)     
  } else if (kind==2){
    return(mean)     
  } else if (kind==3){
    return(out)     
  } 
} # end of function
